Option Strict On
Option Explicit On 
Imports System.Data.SqlClient

Public Interface _clsOmegaBank
	Function VerifyOrHold(ByVal strServer As String, ByVal strUser As String, ByVal strPwd As String, ByVal lngMerchantID As Integer, ByVal lngRefNum As Integer, ByVal strIssuer As String, ByVal strCardNumber As String, ByVal strCardName As String, ByVal strZipCode As String, ByVal strExpDate As String, ByVal curTransactAmt As Decimal, ByVal blnApplyHold As Boolean, ByVal blnUseWS As Boolean) As String
	Function ChargeOrCredit(ByVal strServer As String, ByVal strUser As String, ByVal strPwd As String, ByVal lngMerchantID As Integer, ByVal lngRefNum As Integer, ByVal strCardNumber As String, ByVal lngRelTransactID As Integer, ByVal curTransactAmt As Decimal, ByVal blnReleaseHold As Boolean, ByVal blnCredit As Boolean, ByVal blnUseWS As Boolean) As String
End Interface
<System.Runtime.InteropServices.ProgId("clsOmegaBank_NET.clsOmegaBank")> Public Class clsOmegaBank
	Implements _clsOmegaBank
	
	Public Function VerifyOrHold(ByVal strServer As String, ByVal strUser As String, ByVal strPwd As String, ByVal lngMerchantID As Integer, ByVal lngRefNum As Integer, ByVal strIssuer As String, ByVal strCardNumber As String, ByVal strCardName As String, ByVal strZipCode As String, ByVal strExpDate As String, ByVal curTransactAmt As Decimal, ByVal blnApplyHold As Boolean, ByVal blnUseWS As Boolean) As String Implements _clsOmegaBank.VerifyOrHold
		
		'Verify credit card data, credit availability, and apply holds
		'Returns a string with denied or approved information
		
      'Dim cnnVerify As New ADODB.Connection
      Dim cnnVerify As New SqlConnection()
      'Dim rstVerify As New ADODB.Recordset
      Dim sdrVerify As SqlDataReader = Nothing
		
		Dim strNetConn As String
		Dim strSQL As String
		Dim strExpMonth As String
		Dim strExpYear As String
		Dim datExpDate As Date
		Dim lngTransactID As Integer
      'Dim lngReccnt As Object
      Dim lngReccnt As Integer
      Dim strDateTime As String
      Dim curAvailable As Decimal

      On Error Resume Next

      'strNetConn = "Provider=SQLOLEDB;Data Source=" & strServer & ";Initial Catalog=OMB_Network;UID=" & strUser & ";PWD=" & strPwd
      strNetConn = "Data Source=" & strServer & ";Initial Catalog=OMB_Network;UID=" & strUser & ";PWD=" & strPwd
      'cnnVerify.Open(strNetConn)
      cnnVerify.ConnectionString = strNetConn
      cnnVerify.Open()
      If Err.Number <> 0 Then
         VerifyOrHold = "ERROR: " & Err.Description & " (" & Err.Number & ")"
         GoTo exitVerifyOrHold
      End If

      'Check merchant account
      strSQL = "SELECT COUNT(MerchantID) FROM Merchants " & "WHERE MerchantID = " & CStr(lngMerchantID)
      Dim cmmVerify As SqlCommand = cnnVerify.CreateCommand

      'rstVerify = cnnVerify.Execute(strSQL, , ADODB.CommandTypeEnum.adCmdText)
      'With rstVerify
      '   If CInt(.Fields(0).Value) = 0 Then
      '      VerifyOrHold = "Error: Merchant account " & CStr(lngMerchantID) & " not found."
      '      GoTo exitVerifyOrHold
      '   Else
      '      .Close()
      '   End If
      'End With

      With cmmVerify
         .CommandType = CommandType.Text
         .CommandText = strSQL
         If CInt(.ExecuteScalar()) = 0 Then
            VerifyOrHold = "Error: Merchant account " & CStr(lngMerchantID) & " not found."
            GoTo exitVerifyOrHold
         End If

         'Check credit-card status
         strSQL = "SELECT Canceled, Issuer, CardName, ZipCode, ExpDate, Available " & "FROM Authorize WHERE CardNumber = '" & strCardNumber & "'"
         'rstVerify = cnnVerify.Execute(strSQL, , ADODB.CommandTypeEnum.adCmdText)

         .CommandText = strSQL
         sdrVerify = .ExecuteReader
      End With

      With sdrVerify
         'If .EOF Then
         If .Read Then
            'Calculate expiration date (more trouble than it's worth)
            'strExpDate = CStr(.Fields(4).Value)
            'strExpDate = CStr(.GetDateTime(4))
            'strExpMonth = CStr(Val(Left(strExpDate, 2)))
            'strExpYear = CStr(Val(Right(strExpDate, 2)))
            'If CShort(strExpMonth) = 12 Then
            '   strExpYear = CStr(CShort(strExpYear) + 1)
            'End If
            'datExpDate = CDate(strExpMonth & "/01/" & strExpYear)
            'curAvailable = CDec(.Fields(5).Value)

            datExpDate = CDate(strExpDate)
            curAvailable = .GetDecimal(5)


            'Initial credit-card check
            'If CByte(.Fields(0).Value) = 1 Then
            If .GetBoolean(0) = True Then
               VerifyOrHold = CStr(lngRefNum) & " Declined: " & strIssuer & " " & strCardNumber & " is canceled (19)"
            'ElseIf CStr(.Fields(1).Value) <> strIssuer Then
            ElseIf .GetString(1) <> strIssuer Then
               VerifyOrHold = CStr(lngRefNum) & " Declined: Issuer mismatch (18)"
            'ElseIf CStr(.Fields(2).Value) <> strCardName Then
            ElseIf .GetString(2) <> strCardName Then
               VerifyOrHold = CStr(lngRefNum) & " Declined: Cardholder name mismatch (17)"
            'ElseIf CStr(.Fields(3).Value) <> strZipCode Then
            ElseIf .GetString(3) <> strZipCode Then
               VerifyOrHold = CStr(lngRefNum) & " Declined: Cardholder ZIP Code mismatch (16)"
            'ElseIf CStr(.Fields(4).Value) <> strExpDate Then
            ElseIf .GetDateTime(4) <> datExpDate Then
               VerifyOrHold = CStr(lngRefNum) & " Declined: Expiration date mismatch (15)"
            ElseIf DateDiff(Microsoft.VisualBasic.DateInterval.Day, Today, datExpDate) < 1 Then
               'VerifyOrHold = CStr(lngRefNum) & " Declined: Card expired " & CStr(.Fields(4).Value) & " (13)"
               VerifyOrHold = CStr(lngRefNum) & " Declined: Card expired " & .GetString(4) & " (13)"
            End If
         Else
            VerifyOrHold = CStr(lngRefNum) & " Error: " & strIssuer & " Card number " & strCardNumber & " not found (0)."
         End If
         .Close()
      End With
      If Len(VerifyOrHold) > 0 Then
         GoTo exitVerifyOrHold
      End If

      'Get current available credit
      strSQL = "SELECT SUM(Amount) FROM Transactions WHERE CardNumber = '" & strCardNumber & "' AND AppliedToStatement IS NULL"
      'rstVerify = cnnVerify.Execute(strSQL, , ADODB.CommandTypeEnum.adCmdText)
      'With sdrVerify
      '   If Not .EOF Then
      '      'Holds and charges are negative values
      '      If Not IsDBNull(.Fields(0).Value) Then
      '         curAvailable = curAvailable + CDec(.Fields(0).Value)
      '      End If
      '   End If
      'End With

      With cmmVerify
         .CommandText = strSQL
         If Not IsDBNull(.ExecuteScalar) Then
            curAvailable = curAvailable + CDec(.ExecuteScalar)
         End If
      End With

      'Check available credit
      If curAvailable < curTransactAmt Then
         VerifyOrHold = CStr(lngRefNum) & " Declined: Insufficient credit available (14)"
         GoTo exitVerifyOrHold
      Else
         VerifyOrHold = CStr(lngRefNum) & " Verify Code: " & CStr(Int(1000 * Rnd())) & "OMB" & CStr(Int(100000 * Rnd())) & " (12)"
      End If

      If blnApplyHold Then
         'Change to debit
         curTransactAmt = -curTransactAmt
         strDateTime = CStr(Now)
         'TypeID 31 is "Hold applied by merchant"
         strSQL = "INSERT Transactions(MerchantID, Reference, CardNumber, " & "TransactionDate, TransactionTypeID, Amount) " & "VALUES(" & CStr(lngMerchantID) & ", " & CStr(lngRefNum) & ", '" & strCardNumber & "', '" & strDateTime & "', 31, " & CStr(curTransactAmt) & ")"
         'cnnVerify.Execute(strSQL, lngReccnt, ADODB.CommandTypeEnum.adCmdText)
         With cmmVerify
            .CommandText = strSQL
            lngReccnt = .ExecuteNonQuery
         End With
         'If CInt(lngReccnt) = 1 Then
         If lngReccnt = 1 Then
            'strSQL = "SELECT TransactionID FROM Transactions " & "WHERE Reference = " & CStr(lngRefNum) & " AND TransactionDate = '" & strDateTime & "'"
            'rstVerify = cnnVerify.Execute(strSQL, , ADODB.CommandTypeEnum.adCmdText)
            'Changed to @@IDENTITY
            'With rstVerify
            '   If .EOF Then
            '      VerifyOrHold = CStr(lngRefNum) & " Error: Unable to apply hold (99)"
            '   Else
            '      lngTransactID = CInt(.Fields(0).Value)
            '      VerifyOrHold = CStr(lngRefNum) & " Hold on " & Format(-curTransactAmt, "$#,##0.00") & " applied by TRID " & CStr(lngTransactID) & " (12)"
            '   End If
            '   .Close()
            'End With

            strSQL = "SELECT @@IDENTITY"
            With cmmVerify
               .CommandText = strSQL
               lngTransactID = CInt(.ExecuteScalar)
               VerifyOrHold = CStr(lngRefNum) & " Hold on " & Format(-curTransactAmt, "$#,##0.00") & " applied by TRID " & CStr(lngTransactID) & " (12)"
            End With
         Else
            VerifyOrHold = CStr(lngRefNum) & " Error: Unable to apply hold (99)"
         End If
      End If

exitVerifyOrHold:
         'Clean up
         'With rstVerify
         '   If .State = ADODB.ObjectStateEnum.adStateOpen Then
         '      .Close()
         '   End If
         'End With
         'rstVerify = Nothing
         'With cnnVerify
         '   If .State = ADODB.ObjectStateEnum.adStateOpen Then
         '      .Close()
         '   End If
         'End With
         'UPGRADE_NOTE: Object cnnVerify may not be destroyed until it is garbage collected. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1029"'
         'cnnVerify = Nothing
         sdrVerify.Close()
         cnnVerify.Close()
   End Function

   Public Function ChargeOrCredit(ByVal strServer As String, ByVal strUser As String, ByVal strPwd As String, ByVal lngMerchantID As Integer, ByVal lngRefNum As Integer, ByVal strCardNumber As String, ByVal lngRelTransactID As Integer, ByVal curTransactAmt As Decimal, ByVal blnReleaseHold As Boolean, ByVal blnCredit As Boolean, ByVal blnUseWS As Boolean) As String Implements _clsOmegaBank.ChargeOrCredit

      'Release/reduce hold and charge credit card

      'Dim cnnCharge As New ADODB.Connection()
      Dim cnnCharge As New SqlConnection()
      'Dim rstCharge As New ADODB.Recordset()
      Dim sdrCharge As SqlDataReader = Nothing
      Dim trnCharge As SqlTransaction = Nothing

      Dim strNetConn As String
      Dim strSQL As String
      'Dim lngReccnt As Object
      Dim lngReccnt As Integer
      Dim strDateTime As String
      Dim strStatusID As String
      Dim curHoldAmt As Decimal
      Dim lngTransactID As Integer

      On Error Resume Next

      'strNetConn = "Provider=SQLOLEDB;Data Source=" & strServer & ";Initial Catalog=OMB_Network;UID=" & strUser & ";PWD=" & strPwd
      strNetConn = "Data Source=" & strServer & ";Initial Catalog=OMB_Network;UID=" & strUser & ";PWD=" & strPwd
      'cnnCharge.Open(strNetConn)
      cnnCharge.ConnectionString = strNetConn
      cnnCharge.Open()
      If Err.Number <> 0 Then
         ChargeOrCredit = "ERROR: " & Err.Description & " (" & Err.Number & ")"
         GoTo exitChargeOrCredit
      End If
      strSQL = "SELECT COUNT(MerchantID) FROM Merchants " & "WHERE MerchantID = " & CStr(lngMerchantID)
      'rstCharge = cnnCharge.Execute(strSQL, , ADODB.CommandTypeEnum.adCmdText)
      Dim cmmCharge As SqlCommand = cnnCharge.CreateCommand
      With cmmCharge
         .CommandType = CommandType.Text
         .CommandText = strSQL
         If CInt(.ExecuteScalar) = 0 Then
            ChargeOrCredit = "Error: Merchant account " & CStr(lngMerchantID) & " not found."
            GoTo exitChargeOrCredit
         End If

         'With rstCharge
         '   If CInt(.Fields(0).Value) = 0 Then
         '      ChargeOrCredit = "Error: Merchant account " & CStr(lngMerchantID) & " not found."
         '      GoTo exitChargeOrCredit
         '   Else
         '      .Close()
         '   End If
         'End With

         'strSQL = "SELECT * FROM Transactions WHERE TransactionID = " & CStr(lngRelTransactID)
         strSQL = "SELECT TransactionTypeID, Amount FROM Transactions WHERE TransactionID = " & CStr(lngRelTransactID)
         'rstCharge = cnnCharge.Execute(strSQL, , ADODB.CommandTypeEnum.adCmdText)

         'The following has been restructured

         .CommandText = strSQL
         sdrCharge = .ExecuteReader
      End With
      With sdrCharge
         'If .EOF Then
         If .Read Then
            'TypeID 31 is "Hold applied by merchant"
            'If CByte(.Fields("TransactionTypeID").Value) = 31 Then
            If .GetByte(0) = 31 Then
               'More tests could be applied here
               strDateTime = CStr(Now)
               If blnReleaseHold Then
                  strStatusID = CStr(35) 'Hold Removed by Merchant
                  'curHoldAmt = -CDec(rstCharge.Fields("Amount").Value)
                  curHoldAmt = -.GetDecimal(1)
               Else
                  strStatusID = CStr(34) 'Hold Reduced by Merchant
                  curHoldAmt = curTransactAmt
               End If
            Else
               ChargeOrCredit = CStr(lngRefNum) & " Error: Status of reference transaction is not Apply Hold (99)"
               GoTo exitChargeOrCredit
            End If
         Else
            ChargeOrCredit = "Error: Related transaction " & CStr(lngRelTransactID) & " not found."
            GoTo exitChargeOrCredit
         End If
         .Close()
      End With

      With cmmCharge
         '.BeginTrans()
         trnCharge = cnnCharge.BeginTransaction
         strSQL = "INSERT Transactions(MerchantID, Reference, CardNumber, " & "TransactionDate, TransactionTypeID, Amount, RelatedTransactionID) " & "VALUES(" & CStr(lngMerchantID) & ", " & CStr(lngRefNum) & ", '" & strCardNumber & "', '" & strDateTime & "', 34, " & CStr(curHoldAmt) & ", " & CStr(lngRelTransactID) & ")"
         '.Execute(strSQL, lngReccnt, ADODB.CommandTypeEnum.adCmdText)
         .Transaction = trnCharge
         .CommandText = strSQL
         lngReccnt = .ExecuteNonQuery
         'If CInt(lngReccnt) <> 1 Then
         If lngReccnt <> 1 Then
            'Error
            '.RollbackTrans()
            trnCharge.Rollback()
            ChargeOrCredit = "Error: Unable to commit transaction " & CStr(lngRelTransactID) & " not found."
            GoTo exitChargeOrCredit
         End If
         'StatusID 32 = Debit by Merchant
         curTransactAmt = -curTransactAmt
         strSQL = "INSERT Transactions(MerchantID, Reference, CardNumber, " & "TransactionDate, TransactionTypeID, Amount, RelatedTransactionID) " & "VALUES(" & CStr(lngMerchantID) & ", " & CStr(lngRefNum) & ", '" & strCardNumber & "', '" & strDateTime & "', 32, " & CStr(curTransactAmt) & ", " & CStr(lngRelTransactID) & ")"
         '.Execute(strSQL, lngReccnt, ADODB.CommandTypeEnum.adCmdText)
         .CommandText = strSQL
         lngReccnt = .ExecuteNonQuery
         'If CInt(lngReccnt) = 1 Then
         If lngReccnt = 1 Then
            '.CommitTrans()
            trnCharge.Commit()
         Else
            ChargeOrCredit = CStr(lngRefNum) & " Error: Charge transaction didn't commit (99)"
            '.RollbackTrans()
            trnCharge.Rollback()
            GoTo exitChargeOrCredit
         End If
         strSQL = "SELECT @@IDENTITY"
         .Transaction = Nothing
         .CommandText = strSQL
         lngTransactID = CInt(.ExecuteScalar)
         If lngTransactID > 0 Then
            ChargeOrCredit = CStr(lngRefNum) & " Debit " & Format(curTransactAmt, "$#,##0.00") & " applied by TRID " & CStr(lngTransactID) & " (32)"
         Else
            ChargeOrCredit = CStr(lngRefNum) & " Error: Unable to obtain Transaction ID (99)"
         End If
      End With

      'strSQL = "SELECT @@IDENTITY"

      'rstCharge = cnnCharge.Execute(strSQL, , ADODB.CommandTypeEnum.adCmdText)
      'With rstCharge
      '   If .EOF Then
      '      ChargeOrCredit = CStr(lngRefNum) & " Error: Unable to obtain Transaction ID (99)"
      '   Else
      '      lngTransactID = CInt(.Fields(0).Value)
      '      ChargeOrCredit = CStr(lngRefNum) & " Debit " & Format(curTransactAmt, "$#,##0.00") & " applied by TRID " & CStr(lngTransactID) & " (32)"
      '   End If
      'End With

exitChargeOrCredit:
      sdrCharge.Close()
      cnnCharge.Close()
      'Clean up
      'With rstCharge
      '   If .State = ADODB.ObjectStateEnum.adStateOpen Then
      '      .Close()
      '   End If
      'End With
     ' With cnnCharge
     '    If .State = ADODB.ObjectStateEnum.adStateOpen Then
     '       .Close()
     '    End If
     ' End With
   End Function
End Class