Option Explicit On 
Option Strict On

Imports System.Web.Services
Imports System.Data.SqlClient

<WebService(Namespace:="http://omegabank.com/webservices/", _
   Description:="The OmegaBank Network is a (fictional) full-service credit and debit card transaction-processing facility for merchants accepting American Express, Discover, MasterCharge, and VISA cards. The OmegaBank Web service's VerifyOrHold method enables merchants to verify credit availability and place holds against available credit. The ChargeOrCredit method debits or credits the specified cardholder's account, and releases the credit hold based on its transaction ID.")> _
Public Class OmegaBank
    Inherits System.Web.Services.WebService

#Region " Web Services Designer Generated Code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Web Services Designer.
        InitializeComponent()

        'Add your own initialization code after the InitializeComponent() call

    End Sub

    'Required by the Web Services Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Web Services Designer
    'It can be modified using the Web Services Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        components = New System.ComponentModel.Container()
    End Sub

    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        'CODEGEN: This procedure is required by the Web Services Designer
        'Do not modify it using the code editor.
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

#End Region
   <WebMethod(Description:="<html><p>The VerifyOrHold method requires the following parameter values. OmegaBank provides you with the values for parameters with an asterisk (*) when you complete your service agreement.</p>" & _
         "[1] strServer: The name of the network server* (xsd:string) <br />" & _
         "[2] strUser: Your assigned login ID* (xsd:string) <br />" & _
         "[3] strPwd: Your assigned login password*  (xsd:string) <br />" & _
         "[4] lngMerchantID: Your merchant ID for the specified issuer (xsd:integer) <br />" & _
         "[5] lngRefNum: Your transaction reference, such as an order number (xsd:integer) <br />" & _
         "[6] strIssuer: AMEX, DISC, MAST, or VISA (xsd:string) <br />" & _
         "[7] strCardNumber: All 16 digits of the card number with no hyphens or spaces (xsd:string) <br />" & _
         "[8] strCardName: The cardholder's name as it appears on the card (xsd:string) <br />" & _
         "[9] strZipCode: The cardholders ZIP or ZIP+4 code (xsd:string) <br />" & _
         "[10] strExpDate: The card expiration date in MM-YY format (xsd:string) <br />" & _
         "[11] curTransactAmt: The amount to verify or hold, in ####.## format (xsd:decimal) <br />" & _
         "[12] blnApplyHold: False to verify, True to hold (xsd:boolean) <br />" & _
         "[13] blnUseWS: Always True (xsd:boolean) <br />" & _
         "[Verify Response] If credit availibility is greater than the transaction amount, the service returns the following string: <br />" & _
         "'407162 Verify Code: 705OMB53342 (12)'. The initial number is your lngRefNum value. <br />" & _
         "[Declined Response] If credit availibility is less than the transaction amount, the service returns the following string: <br />" & _
         "'407166 Declined: Insufficient credit available (14)'. Your merchant agreement describes other transaction declined responses. <br />" & _
         "[Hold Response] If credit availability is greater than the transaction amount, the service returns the following string: <br />" & _
         "'407168 Hold on $726.23 applied by TRID 5287716 (12)'. You use the transaction ID (TRID) when debiting the card for the hold amount or less. <br />" & _
         "Otherwise, the string returns a declined response.</html>")> _
      Public Function VerifyOrHold(ByVal strServer As String, ByVal strUser As String, ByVal strPwd As String, ByVal lngMerchantID As Integer, ByVal lngRefNum As Integer, ByVal strIssuer As String, ByVal strCardNumber As String, ByVal strCardName As String, ByVal strZipCode As String, ByVal strExpDate As String, ByVal curTransactAmt As Decimal, ByVal blnApplyHold As Boolean, ByVal blnUseWS As Boolean) As String
      'Verify credit card data, credit availability, and apply holds
      'Returns a string with denied or approved information

      Dim cnnVerify As New SqlConnection()
      Dim sdrVerify As SqlDataReader = Nothing

      Dim strNetConn As String
      Dim strSQL As String
      Dim strExpMonth As String
      Dim strExpYear As String
      Dim datExpDate As Date
      Dim lngTransactID As Integer
      Dim lngReccnt As Integer
      Dim strDateTime As String
      Dim curAvailable As Decimal

      On Error Resume Next

      strNetConn = "Data Source=" & strServer & ";Initial Catalog=OMB_Network;UID=" & strUser & ";PWD=" & strPwd
      cnnVerify.ConnectionString = strNetConn
      cnnVerify.Open()
      If Err.Number <> 0 Then
         VerifyOrHold = "ERROR: " & Err.Description & " (" & Err.Number & ")"
         GoTo exitVerifyOrHold
      End If

      'Check merchant account
      strSQL = "SELECT COUNT(MerchantID) FROM Merchants " & "WHERE MerchantID = " & CStr(lngMerchantID)
      Dim cmmVerify As SqlCommand = cnnVerify.CreateCommand
      With cmmVerify
         .CommandType = CommandType.Text
         .CommandText = strSQL
         If CInt(.ExecuteScalar()) = 0 Then
            VerifyOrHold = "Error: Merchant account " & CStr(lngMerchantID) & " not found."
            GoTo exitVerifyOrHold
         End If

         'Check credit-card status
         strSQL = "SELECT Canceled, Issuer, CardName, ZipCode, ExpDate, Available " & "FROM Authorize WHERE CardNumber = '" & strCardNumber & "'"
         .CommandText = strSQL
         sdrVerify = .ExecuteReader
      End With

      With sdrVerify
         'If .EOF Then
         If .Read Then
            datExpDate = CDate(strExpDate)
            curAvailable = .GetDecimal(5)
            'Initial credit-card check
            If .GetBoolean(0) = True Then
               VerifyOrHold = CStr(lngRefNum) & " Declined: " & strIssuer & " " & strCardNumber & " is canceled (19)"
            ElseIf .GetString(1) <> strIssuer Then
               VerifyOrHold = CStr(lngRefNum) & " Declined: Issuer mismatch (18)"
            ElseIf .GetString(2) <> strCardName Then
               VerifyOrHold = CStr(lngRefNum) & " Declined: Cardholder name mismatch (17)"
            ElseIf .GetString(3) <> strZipCode Then
               VerifyOrHold = CStr(lngRefNum) & " Declined: Cardholder ZIP Code mismatch (16)"
            ElseIf .GetDateTime(4) <> datExpDate Then
               VerifyOrHold = CStr(lngRefNum) & " Declined: Expiration date mismatch (15)"
            ElseIf DateDiff(Microsoft.VisualBasic.DateInterval.Day, Today, datExpDate) < 1 Then
               'VerifyOrHold = CStr(lngRefNum) & " Declined: Card expired " & CStr(.Fields(4).Value) & " (13)"
               VerifyOrHold = CStr(lngRefNum) & " Declined: Card expired " & .GetString(4) & " (13)"
            End If
         Else
            VerifyOrHold = CStr(lngRefNum) & " Error: " & strIssuer & " Card number " & strCardNumber & " not found (0)."
         End If
         .Close()
      End With
      If Len(VerifyOrHold) > 0 Then
         GoTo exitVerifyOrHold
      End If

      'Get current available credit
      strSQL = "SELECT SUM(Amount) FROM Transactions WHERE CardNumber = '" & strCardNumber & "' AND AppliedToStatement IS NULL"
      With cmmVerify
         .CommandText = strSQL
         If Not IsDBNull(.ExecuteScalar) Then
            curAvailable = curAvailable + CDec(.ExecuteScalar)
         End If
      End With

      'Check available credit
      If curAvailable < curTransactAmt Then
         VerifyOrHold = CStr(lngRefNum) & " Declined: Insufficient credit available (14)"
         GoTo exitVerifyOrHold
      Else
         VerifyOrHold = CStr(lngRefNum) & " Verify Code: " & CStr(Int(1000 * Rnd())) & "OMB" & CStr(Int(100000 * Rnd())) & " (12)"
      End If

      If blnApplyHold Then
         'Change to debit
         curTransactAmt = -curTransactAmt
         strDateTime = CStr(Now)
         'TypeID 31 is "Hold applied by merchant"
         strSQL = "INSERT Transactions(MerchantID, Reference, CardNumber, " & "TransactionDate, TransactionTypeID, Amount) " & "VALUES(" & CStr(lngMerchantID) & ", " & CStr(lngRefNum) & ", '" & strCardNumber & "', '" & strDateTime & "', 31, " & CStr(curTransactAmt) & ")"
         With cmmVerify
            .CommandText = strSQL
            lngReccnt = .ExecuteNonQuery
         End With
         If lngReccnt = 1 Then
            strSQL = "SELECT @@IDENTITY"
            With cmmVerify
               .CommandText = strSQL
               lngTransactID = CInt(.ExecuteScalar)
               VerifyOrHold = CStr(lngRefNum) & " Hold on " & Format(-curTransactAmt, "$#,##0.00") & " applied by TRID " & CStr(lngTransactID) & " (12)"
            End With
         Else
            VerifyOrHold = CStr(lngRefNum) & " Error: Unable to apply hold (99)"
         End If
      End If

exitVerifyOrHold:
         sdrVerify.Close()
         cnnVerify.Close()
   End Function

<WebMethod(Description:="<html><p>The ChargeOrCredit method requires the following parameter values. OmegaBank provides you with the values for parameters with an asterisk (*) when you complete your service agreement.</p>" & _
         "[1] strServer: The name of the network server* (xsd:string) <br />" & _
         "[2] strUser: Your assigned login ID* (xsd:string) <br />" & _
         "[3] strPwd: Your assigned login password*  (xsd:string) <br />" & _
         "[4] lngMerchantID: Your merchant ID for the specified issuer (xsd:integer) <br />" & _
         "[5] lngRefNum: Your transaction reference, such as an order number (xsd:integer) <br />" & _
         "[6] strCardNumber: All 16 digits of the card number with no hyphens or spaces (xsd:string) <br />" & _
         "[7] lngRelTransactID: The TRID value returned by the hold transaction (xsd:integer) <br />" & _
         "[8] curTransactAmt: The amount to verify or hold, in ####.## format (xsd:decimal) <br />" & _
         "[9] blnReleaseHold: True to release the entire amount held; False otherwise (xsd:boolean) <br />" & _
         "[10] blnCredit: True to issue a credit for the transaction amount; False to debit card (xsd:boolean) <br />" & _
         "[11] blnUseWS: Always True (xsd:boolean) <br />" & _
         "[Debit Response] If the charge transaction succeeds, you receive the following string: <br />" & _
         "'407168 Debit -$686.88 applied by TRID 5287718 (61)'. <br />" & _
         "[Credit Response] If the credit transaction succeeds, you receive the following string: <br />" & _
         "'407168 Credit $686.88 applied by TRID 5287722 (71)'. <br />" & _
         "Otherwise, the string returns a declined response, as described in your merchant agreement.</html>")> _
Public Function ChargeOrCredit(ByVal strServer As String, ByVal strUser As String, ByVal strPwd As String, ByVal lngMerchantID As Integer, ByVal lngRefNum As Integer, ByVal strCardNumber As String, ByVal lngRelTransactID As Integer, ByVal curTransactAmt As Decimal, ByVal blnReleaseHold As Boolean, ByVal blnCredit As Boolean, ByVal blnUseWS As Boolean) As String
      'Release/reduce hold and charge credit card

      Dim cnnCharge As New SqlConnection()
      Dim sdrCharge As SqlDataReader = Nothing
      Dim trnCharge As SqlTransaction = Nothing

      Dim strNetConn As String
      Dim strSQL As String
      Dim lngReccnt As Integer
      Dim strDateTime As String
      Dim strStatusID As String
      Dim curHoldAmt As Decimal
      Dim lngTransactID As Integer

      On Error Resume Next

      strNetConn = "Data Source=" & strServer & ";Initial Catalog=OMB_Network;UID=" & strUser & ";PWD=" & strPwd
      cnnCharge.ConnectionString = strNetConn
      cnnCharge.Open()
      If Err.Number <> 0 Then
         ChargeOrCredit = "ERROR: " & Err.Description & " (" & Err.Number & ")"
         GoTo exitChargeOrCredit
      End If
      strSQL = "SELECT COUNT(MerchantID) FROM Merchants " & "WHERE MerchantID = " & CStr(lngMerchantID)
      Dim cmmCharge As SqlCommand = cnnCharge.CreateCommand
      With cmmCharge
         .CommandType = CommandType.Text
         .CommandText = strSQL
         If CInt(.ExecuteScalar) = 0 Then
            ChargeOrCredit = "Error: Merchant account " & CStr(lngMerchantID) & " not found."
            GoTo exitChargeOrCredit
         End If
         strSQL = "SELECT TransactionTypeID, Amount FROM Transactions WHERE TransactionID = " & CStr(lngRelTransactID)
         .CommandText = strSQL
         sdrCharge = .ExecuteReader
      End With
      With sdrCharge
         If .Read Then
            'TypeID 31 is "Hold applied by merchant"
            If .GetByte(0) = 31 Then
               strDateTime = CStr(Now)
               If blnReleaseHold Then
                  strStatusID = CStr(35) 'Hold Removed by Merchant
                  curHoldAmt = -.GetDecimal(1)
               Else
                  strStatusID = CStr(34) 'Hold Reduced by Merchant
                  curHoldAmt = curTransactAmt
               End If
            Else
               ChargeOrCredit = CStr(lngRefNum) & " Error: Status of reference transaction is not Apply Hold (99)"
               GoTo exitChargeOrCredit
            End If
         Else
            ChargeOrCredit = "Error: Related transaction " & CStr(lngRelTransactID) & " not found."
            GoTo exitChargeOrCredit
         End If
         .Close()
      End With

      With cmmCharge
         trnCharge = cnnCharge.BeginTransaction
         strSQL = "INSERT Transactions(MerchantID, Reference, CardNumber, " & "TransactionDate, TransactionTypeID, Amount, RelatedTransactionID) " & "VALUES(" & CStr(lngMerchantID) & ", " & CStr(lngRefNum) & ", '" & strCardNumber & "', '" & strDateTime & "', 34, " & CStr(curHoldAmt) & ", " & CStr(lngRelTransactID) & ")"
         .Transaction = trnCharge
         .CommandText = strSQL
         lngReccnt = .ExecuteNonQuery
         If lngReccnt <> 1 Then
            'Error
            trnCharge.Rollback()
            ChargeOrCredit = "Error: Unable to commit transaction " & CStr(lngRelTransactID) & " not found."
            GoTo exitChargeOrCredit
         End If
         'StatusID 32 = Debit by Merchant
         curTransactAmt = -curTransactAmt
         strSQL = "INSERT Transactions(MerchantID, Reference, CardNumber, " & "TransactionDate, TransactionTypeID, Amount, RelatedTransactionID) " & "VALUES(" & CStr(lngMerchantID) & ", " & CStr(lngRefNum) & ", '" & strCardNumber & "', '" & strDateTime & "', 32, " & CStr(curTransactAmt) & ", " & CStr(lngRelTransactID) & ")"
         .CommandText = strSQL
         lngReccnt = .ExecuteNonQuery
         If lngReccnt = 1 Then
            trnCharge.Commit()
         Else
            ChargeOrCredit = CStr(lngRefNum) & " Error: Charge transaction didn't commit (99)"
            trnCharge.Rollback()
            GoTo exitChargeOrCredit
         End If
         strSQL = "SELECT @@IDENTITY"
         .Transaction = Nothing
         .CommandText = strSQL
         lngTransactID = CInt(.ExecuteScalar)
         If lngTransactID > 0 Then
            ChargeOrCredit = CStr(lngRefNum) & " Debit " & Format(curTransactAmt, "$#,##0.00") & " applied by TRID " & CStr(lngTransactID) & " (32)"
         Else
            ChargeOrCredit = CStr(lngRefNum) & " Error: Unable to obtain Transaction ID (99)"
         End If
      End With

exitChargeOrCredit:
      sdrCharge.Close()
      cnnCharge.Close()
   End Function

End Class
