Option Explicit On 
Option Strict Off
Imports Microsoft.VisualBasic
Imports System.IO
Imports System.Xml

Public Class frmAlphaDist
   Inherits System.Windows.Forms.Form

   Private strCat1 As String = "AMPL"
   Private strCat2 As String = "DVCC"
   Private strCat3 As String = "DVDP"
   Private strCat4 As String = "RCVH"
   Private strCat5 As String = "SPKF"
   Private strCat6 As String = "TVRC"
   Private strHelp As String

   Private dtProds As New DataTable("Products")
   Friend WithEvents txtErrors As System.Windows.Forms.TextBox
   Friend WithEvents DataGridTableStyle1 As System.Windows.Forms.DataGridTableStyle
   Friend WithEvents DataGridTextBoxColumn1 As System.Windows.Forms.DataGridTextBoxColumn
   Friend WithEvents DataGridTextBoxColumn2 As System.Windows.Forms.DataGridTextBoxColumn
   Friend WithEvents DataGridTextBoxColumn3 As System.Windows.Forms.DataGridTextBoxColumn
   Friend WithEvents DataGridTextBoxColumn4 As System.Windows.Forms.DataGridTextBoxColumn
   Friend WithEvents DataGridTextBoxColumn5 As System.Windows.Forms.DataGridTextBoxColumn
   Friend WithEvents DataGridTextBoxColumn6 As System.Windows.Forms.DataGridTextBoxColumn
   Friend WithEvents DataGridTextBoxColumn7 As System.Windows.Forms.DataGridTextBoxColumn
   Friend WithEvents txtHelp As System.Windows.Forms.TextBox
   Friend WithEvents chkRemote As System.Windows.Forms.CheckBox
   Friend WithEvents txtConsume As System.Windows.Forms.TextBox
   Friend WithEvents lblTotalTime As System.Windows.Forms.Label
   Friend WithEvents txtTotal As System.Windows.Forms.TextBox
   Friend WithEvents lblConsume As System.Windows.Forms.Label

#Region " Windows Form Designer generated code "

   Public Sub New()
      MyBase.New()

      'This call is required by the Windows Form Designer.
      InitializeComponent()
      'Add any initialization after the InitializeComponent() call
      With dtProds
         .Columns.Add("SKU", Type.GetType("System.String"))
         .Columns.Add("Category", Type.GetType("System.String"))
         .Columns.Add("Brand", Type.GetType("System.String"))
         .Columns.Add("Model", Type.GetType("System.String"))
         .Columns.Add("Description", Type.GetType("System.String"))
         .Columns.Add("Net Price", Type.GetType("System.String"))
         .Columns.Add("Quan.", Type.GetType("System.String"))
      End With
      dgProds.DataSource = dtProds
      strHelp = "This project is a Visual Basic .NET XML Web services client, "
      strHelp += "which demonstrates the SOAP-enabling features of SQLXML 3.0. "
      strHelp += "The client retrieves data by invoking an Alpha Web service method: one of "
      strHelp += "four 'GetTop###' Transact-SQL stored procedures of OakLeaf Systems' AlphaDist "
      strHelp += "SQL Server 2000 database." + Chr(13) + Chr(10) + Chr(13) + Chr(10)
      strHelp += "The OakLeaf Alpha XML Web service uses the XML Objects (default) or DataSet Objects option on the Soap [sic] Virtual Name Configuration page to return the specified rowset as a "
      strHelp += "single element-centric XML document. A few lines of code extract the "
      strHelp += "attribute values from an XmlTextReader object to populate a DataTable, "
      strHelp += "which serves as the DataSource for the DataGrid." + Chr(13) + Chr(10) + Chr(13) + Chr(10)
      strHelp += "Select the number of records and the product categories you want "
      strHelp += "and click Retrieve Data to populate the DataGrid. The products are real, but the prices are fictitious."
      txtHelp.Text = strHelp
   End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub
   Friend WithEvents grpTop As System.Windows.Forms.GroupBox
   Friend WithEvents optTop10 As System.Windows.Forms.RadioButton
   Friend WithEvents optTop25 As System.Windows.Forms.RadioButton
   Friend WithEvents optTop50 As System.Windows.Forms.RadioButton
   Friend WithEvents optTop100 As System.Windows.Forms.RadioButton
   Friend WithEvents chkCat1 As System.Windows.Forms.CheckBox
   Friend WithEvents chkCat2 As System.Windows.Forms.CheckBox
   Friend WithEvents chkCat3 As System.Windows.Forms.CheckBox
   Friend WithEvents chkCat4 As System.Windows.Forms.CheckBox
   Friend WithEvents chkCat5 As System.Windows.Forms.CheckBox
   Friend WithEvents chkCat6 As System.Windows.Forms.CheckBox
   Friend WithEvents grpCategories As System.Windows.Forms.GroupBox
   Friend WithEvents dgProds As System.Windows.Forms.DataGrid
   Friend WithEvents cmdExecute As System.Windows.Forms.Button

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
Me.grpTop = New System.Windows.Forms.GroupBox()
Me.optTop100 = New System.Windows.Forms.RadioButton()
Me.optTop50 = New System.Windows.Forms.RadioButton()
Me.optTop25 = New System.Windows.Forms.RadioButton()
Me.optTop10 = New System.Windows.Forms.RadioButton()
Me.chkCat1 = New System.Windows.Forms.CheckBox()
Me.chkCat2 = New System.Windows.Forms.CheckBox()
Me.chkCat3 = New System.Windows.Forms.CheckBox()
Me.chkCat4 = New System.Windows.Forms.CheckBox()
Me.chkCat5 = New System.Windows.Forms.CheckBox()
Me.chkCat6 = New System.Windows.Forms.CheckBox()
Me.grpCategories = New System.Windows.Forms.GroupBox()
Me.dgProds = New System.Windows.Forms.DataGrid()
Me.DataGridTableStyle1 = New System.Windows.Forms.DataGridTableStyle()
Me.DataGridTextBoxColumn1 = New System.Windows.Forms.DataGridTextBoxColumn()
Me.DataGridTextBoxColumn2 = New System.Windows.Forms.DataGridTextBoxColumn()
Me.DataGridTextBoxColumn3 = New System.Windows.Forms.DataGridTextBoxColumn()
Me.DataGridTextBoxColumn4 = New System.Windows.Forms.DataGridTextBoxColumn()
Me.DataGridTextBoxColumn5 = New System.Windows.Forms.DataGridTextBoxColumn()
Me.DataGridTextBoxColumn6 = New System.Windows.Forms.DataGridTextBoxColumn()
Me.DataGridTextBoxColumn7 = New System.Windows.Forms.DataGridTextBoxColumn()
Me.cmdExecute = New System.Windows.Forms.Button()
Me.txtErrors = New System.Windows.Forms.TextBox()
Me.txtHelp = New System.Windows.Forms.TextBox()
Me.chkRemote = New System.Windows.Forms.CheckBox()
Me.lblConsume = New System.Windows.Forms.Label()
Me.txtConsume = New System.Windows.Forms.TextBox()
Me.lblTotalTime = New System.Windows.Forms.Label()
Me.txtTotal = New System.Windows.Forms.TextBox()
Me.grpTop.SuspendLayout()
CType(Me.dgProds, System.ComponentModel.ISupportInitialize).BeginInit()
Me.SuspendLayout()
'
'grpTop
'
Me.grpTop.Controls.AddRange(New System.Windows.Forms.Control() {Me.optTop100, Me.optTop50, Me.optTop25, Me.optTop10})
Me.grpTop.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
Me.grpTop.Location = New System.Drawing.Point(16, 16)
Me.grpTop.Name = "grpTop"
Me.grpTop.Size = New System.Drawing.Size(128, 104)
Me.grpTop.TabIndex = 0
Me.grpTop.TabStop = False
Me.grpTop.Text = "Number of Records"
'
'optTop100
'
Me.optTop100.Location = New System.Drawing.Point(16, 79)
Me.optTop100.Name = "optTop100"
Me.optTop100.Size = New System.Drawing.Size(75, 16)
Me.optTop100.TabIndex = 3
Me.optTop100.Text = "Top 100"
'
'optTop50
'
Me.optTop50.Location = New System.Drawing.Point(16, 58)
Me.optTop50.Name = "optTop50"
Me.optTop50.Size = New System.Drawing.Size(75, 16)
Me.optTop50.TabIndex = 2
Me.optTop50.Text = "Top 50"
'
'optTop25
'
Me.optTop25.Location = New System.Drawing.Point(16, 37)
Me.optTop25.Name = "optTop25"
Me.optTop25.Size = New System.Drawing.Size(75, 16)
Me.optTop25.TabIndex = 1
Me.optTop25.Text = "Top 25"
'
'optTop10
'
Me.optTop10.Checked = True
Me.optTop10.Location = New System.Drawing.Point(16, 16)
Me.optTop10.Name = "optTop10"
Me.optTop10.Size = New System.Drawing.Size(75, 16)
Me.optTop10.TabIndex = 0
Me.optTop10.TabStop = True
Me.optTop10.Text = "Top 10"
'
'chkCat1
'
Me.chkCat1.Checked = True
Me.chkCat1.CheckState = System.Windows.Forms.CheckState.Checked
Me.chkCat1.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
Me.chkCat1.Location = New System.Drawing.Point(184, 32)
Me.chkCat1.Name = "chkCat1"
Me.chkCat1.Size = New System.Drawing.Size(112, 16)
Me.chkCat1.TabIndex = 1
Me.chkCat1.Text = "Amplifiers"
'
'chkCat2
'
Me.chkCat2.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
Me.chkCat2.Location = New System.Drawing.Point(184, 51)
Me.chkCat2.Name = "chkCat2"
Me.chkCat2.Size = New System.Drawing.Size(112, 16)
Me.chkCat2.TabIndex = 2
Me.chkCat2.Text = "DV Camcorders"
'
'chkCat3
'
Me.chkCat3.Checked = True
Me.chkCat3.CheckState = System.Windows.Forms.CheckState.Checked
Me.chkCat3.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
Me.chkCat3.Location = New System.Drawing.Point(184, 70)
Me.chkCat3.Name = "chkCat3"
Me.chkCat3.Size = New System.Drawing.Size(112, 16)
Me.chkCat3.TabIndex = 3
Me.chkCat3.Text = "DVD Players"
'
'chkCat4
'
Me.chkCat4.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
Me.chkCat4.Location = New System.Drawing.Point(184, 89)
Me.chkCat4.Name = "chkCat4"
Me.chkCat4.Size = New System.Drawing.Size(120, 16)
Me.chkCat4.TabIndex = 4
Me.chkCat4.Text = "Receivers (Home)"
'
'chkCat5
'
Me.chkCat5.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
Me.chkCat5.Location = New System.Drawing.Point(184, 108)
Me.chkCat5.Name = "chkCat5"
Me.chkCat5.Size = New System.Drawing.Size(112, 16)
Me.chkCat5.TabIndex = 5
Me.chkCat5.Text = "Speakers (Floor)"
'
'chkCat6
'
Me.chkCat6.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
Me.chkCat6.Location = New System.Drawing.Point(184, 127)
Me.chkCat6.Name = "chkCat6"
Me.chkCat6.Size = New System.Drawing.Size(112, 16)
Me.chkCat6.TabIndex = 6
Me.chkCat6.Text = "TV Sets"
'
'grpCategories
'
Me.grpCategories.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
Me.grpCategories.Location = New System.Drawing.Point(168, 16)
Me.grpCategories.Name = "grpCategories"
Me.grpCategories.Size = New System.Drawing.Size(144, 136)
Me.grpCategories.TabIndex = 7
Me.grpCategories.TabStop = False
Me.grpCategories.Text = "Include Categories"
'
'dgProds
'
Me.dgProds.AllowSorting = False
Me.dgProds.BackgroundColor = System.Drawing.Color.Silver
Me.dgProds.CaptionText = "Selected Consumer Electronic Products Sorted by Descending Net Price"
Me.dgProds.DataMember = ""
Me.dgProds.HeaderFont = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
Me.dgProds.HeaderForeColor = System.Drawing.SystemColors.ControlText
Me.dgProds.Location = New System.Drawing.Point(16, 200)
Me.dgProds.Name = "dgProds"
Me.dgProds.ReadOnly = True
Me.dgProds.Size = New System.Drawing.Size(632, 216)
Me.dgProds.TabIndex = 8
Me.dgProds.TableStyles.AddRange(New System.Windows.Forms.DataGridTableStyle() {Me.DataGridTableStyle1})
'
'DataGridTableStyle1
'
Me.DataGridTableStyle1.AllowSorting = False
Me.DataGridTableStyle1.DataGrid = Me.dgProds
Me.DataGridTableStyle1.GridColumnStyles.AddRange(New System.Windows.Forms.DataGridColumnStyle() {Me.DataGridTextBoxColumn1, Me.DataGridTextBoxColumn2, Me.DataGridTextBoxColumn3, Me.DataGridTextBoxColumn4, Me.DataGridTextBoxColumn5, Me.DataGridTextBoxColumn6, Me.DataGridTextBoxColumn7})
Me.DataGridTableStyle1.HeaderForeColor = System.Drawing.SystemColors.ControlText
Me.DataGridTableStyle1.MappingName = "Products"
Me.DataGridTableStyle1.RowHeadersVisible = False
'
'DataGridTextBoxColumn1
'
Me.DataGridTextBoxColumn1.Format = ""
Me.DataGridTextBoxColumn1.FormatInfo = Nothing
Me.DataGridTextBoxColumn1.HeaderText = "SKU"
Me.DataGridTextBoxColumn1.MappingName = "SKU"
Me.DataGridTextBoxColumn1.Width = 65
'
'DataGridTextBoxColumn2
'
Me.DataGridTextBoxColumn2.Format = ""
Me.DataGridTextBoxColumn2.FormatInfo = Nothing
Me.DataGridTextBoxColumn2.HeaderText = "Category"
Me.DataGridTextBoxColumn2.MappingName = "Category"
Me.DataGridTextBoxColumn2.Width = 90
'
'DataGridTextBoxColumn3
'
Me.DataGridTextBoxColumn3.Format = ""
Me.DataGridTextBoxColumn3.FormatInfo = Nothing
Me.DataGridTextBoxColumn3.HeaderText = "Brand"
Me.DataGridTextBoxColumn3.MappingName = "Brand"
Me.DataGridTextBoxColumn3.Width = 50
'
'DataGridTextBoxColumn4
'
Me.DataGridTextBoxColumn4.Format = ""
Me.DataGridTextBoxColumn4.FormatInfo = Nothing
Me.DataGridTextBoxColumn4.HeaderText = "Model"
Me.DataGridTextBoxColumn4.MappingName = "Model"
Me.DataGridTextBoxColumn4.Width = 90
'
'DataGridTextBoxColumn5
'
Me.DataGridTextBoxColumn5.Format = ""
Me.DataGridTextBoxColumn5.FormatInfo = Nothing
Me.DataGridTextBoxColumn5.HeaderText = "Description"
Me.DataGridTextBoxColumn5.MappingName = "Description"
Me.DataGridTextBoxColumn5.Width = 220
'
'DataGridTextBoxColumn6
'
Me.DataGridTextBoxColumn6.Alignment = System.Windows.Forms.HorizontalAlignment.Right
Me.DataGridTextBoxColumn6.Format = ""
Me.DataGridTextBoxColumn6.FormatInfo = Nothing
Me.DataGridTextBoxColumn6.HeaderText = "Net Price"
Me.DataGridTextBoxColumn6.MappingName = "Net Price"
Me.DataGridTextBoxColumn6.Width = 60
'
'DataGridTextBoxColumn7
'
Me.DataGridTextBoxColumn7.Alignment = System.Windows.Forms.HorizontalAlignment.Center
Me.DataGridTextBoxColumn7.Format = ""
Me.DataGridTextBoxColumn7.FormatInfo = Nothing
Me.DataGridTextBoxColumn7.HeaderText = "Quan."
Me.DataGridTextBoxColumn7.MappingName = "Quan."
Me.DataGridTextBoxColumn7.Width = 40
'
'cmdExecute
'
Me.cmdExecute.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
Me.cmdExecute.Location = New System.Drawing.Point(16, 128)
Me.cmdExecute.Name = "cmdExecute"
Me.cmdExecute.Size = New System.Drawing.Size(128, 24)
Me.cmdExecute.TabIndex = 9
Me.cmdExecute.Text = "Retrieve Data"
'
'txtErrors
'
Me.txtErrors.Location = New System.Drawing.Point(336, 24)
Me.txtErrors.Multiline = True
Me.txtErrors.Name = "txtErrors"
Me.txtErrors.ScrollBars = System.Windows.Forms.ScrollBars.Horizontal
Me.txtErrors.Size = New System.Drawing.Size(312, 128)
Me.txtErrors.TabIndex = 10
Me.txtErrors.Text = ""
Me.txtErrors.Visible = False
'
'txtHelp
'
Me.txtHelp.BackColor = System.Drawing.SystemColors.Control
Me.txtHelp.BorderStyle = System.Windows.Forms.BorderStyle.None
Me.txtHelp.ForeColor = System.Drawing.Color.Black
Me.txtHelp.Location = New System.Drawing.Point(336, 24)
Me.txtHelp.Multiline = True
Me.txtHelp.Name = "txtHelp"
Me.txtHelp.ReadOnly = True
Me.txtHelp.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
Me.txtHelp.Size = New System.Drawing.Size(312, 128)
Me.txtHelp.TabIndex = 11
Me.txtHelp.TabStop = False
Me.txtHelp.Text = "Help Text"
'
'chkRemote
'
Me.chkRemote.Location = New System.Drawing.Point(16, 168)
Me.chkRemote.Name = "chkRemote"
Me.chkRemote.Size = New System.Drawing.Size(280, 16)
Me.chkRemote.TabIndex = 12
Me.chkRemote.Text = "Use Remote OakLeaf Alpha XML Web Service"
'
'lblConsume
'
Me.lblConsume.Location = New System.Drawing.Point(328, 168)
Me.lblConsume.Name = "lblConsume"
Me.lblConsume.Size = New System.Drawing.Size(144, 16)
Me.lblConsume.TabIndex = 13
Me.lblConsume.Text = "Time to Consume Service:"
'
'txtConsume
'
Me.txtConsume.Location = New System.Drawing.Point(480, 164)
Me.txtConsume.Name = "txtConsume"
Me.txtConsume.ReadOnly = True
Me.txtConsume.Size = New System.Drawing.Size(48, 20)
Me.txtConsume.TabIndex = 14
Me.txtConsume.Text = ""
Me.txtConsume.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
'
'lblTotalTime
'
Me.lblTotalTime.Location = New System.Drawing.Point(533, 168)
Me.lblTotalTime.Name = "lblTotalTime"
Me.lblTotalTime.Size = New System.Drawing.Size(64, 16)
Me.lblTotalTime.TabIndex = 15
Me.lblTotalTime.Text = "Total Time:"
'
'txtTotal
'
Me.txtTotal.Location = New System.Drawing.Point(600, 163)
Me.txtTotal.Name = "txtTotal"
Me.txtTotal.ReadOnly = True
Me.txtTotal.Size = New System.Drawing.Size(48, 20)
Me.txtTotal.TabIndex = 16
Me.txtTotal.Text = ""
Me.txtTotal.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
'
'frmAlphaDist
'
Me.AutoScaleBaseSize = New System.Drawing.Size(6, 13)
Me.ClientSize = New System.Drawing.Size(664, 429)
Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.txtTotal, Me.lblTotalTime, Me.txtConsume, Me.lblConsume, Me.chkRemote, Me.txtHelp, Me.txtErrors, Me.cmdExecute, Me.dgProds, Me.grpTop, Me.chkCat1, Me.chkCat4, Me.chkCat2, Me.chkCat5, Me.chkCat6, Me.chkCat3, Me.grpCategories})
Me.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
Me.Name = "frmAlphaDist"
Me.Text = "OakLeaf Systems - SQL Server 2000 Stored Procedures as XML Web Services (SQLXML 3" & _
".0)"
Me.grpTop.ResumeLayout(False)
CType(Me.dgProds, System.ComponentModel.ISupportInitialize).EndInit()
Me.ResumeLayout(False)

    End Sub

#End Region

   Private Sub cmdExecute_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdExecute.Click
      Dim prxRemote As New AlphaRemote.Alpha()  'Remote OakLeaf Alpha service
      Dim prxLocal As New AlphaLocal.Alpha()
      Dim prxAlpha As Object
      Dim objResult As New Object()
      Dim dsData As DataSet
      Dim xmlData As XmlElement
      Dim msgRemote As AlphaRemote.SqlMessage
      Dim msgLocal As AlphaLocal.SqlMessage
      Dim msgError As Object
      Dim srdData As StringReader
      Dim xtrData As XmlTextReader
      Dim drProds As DataRow
      Dim dblTime As Double
      Dim dblConsume As Double
      Dim dblTotal As Double
      Dim dsResult As DataSet

      Dim strHeader As String
      'Dim intRetVal As Integer
      Dim intObj As Integer
      Dim strXmlData As String
      Dim strData As String
      Dim strRow As String
      Dim strError As String
      Dim intCol As Integer
      Dim strCol As String
      Dim blnGotData As Boolean

      txtErrors.Visible = False
      txtHelp.Visible = True
      txtConsume.Text = ""
      txtTotal.Text = ""
      dtProds.Clear()

      'Product category selection
      If chkCat1.Checked Then
         strCat1 = "AMPL"
      Else
         strCat1 = "XXXX"
      End If
      If chkCat2.Checked Then
         strCat2 = "DVCC"
      Else
         strCat2 = "XXXX"
      End If
      If chkCat3.Checked Then
         strCat3 = "DVDP"
      Else
         strCat3 = "XXXX"
      End If
      If chkCat4.Checked Then
         strCat4 = "RCVH"
      Else
         strCat4 = "XXXX"
      End If
      If chkCat5.Checked Then
         strCat5 = "SPKF"
      Else
         strCat5 = "XXXX"
      End If
      If chkCat6.Checked Then
         strCat6 = "TVRC"
      Else
         strCat6 = "XXXX"
      End If

      If chkRemote.Checked Then
         'Use the OakLeaf Alpha service
         prxAlpha = prxRemote
         msgError = msgRemote
      Else
         prxAlpha = prxLocal
         msgError = msgLocal
      End If

      dblTime = Timer

      'Rows returned
      If optTop10.Checked Then
         objResult = prxAlpha.GetTop10(strCat1, strCat2, strCat3, strCat4, strCat5, strCat6)
         strHeader = "Top 10 "
      ElseIf optTop25.Checked Then
         objResult = prxAlpha.GetTop25(strCat1, strCat2, strCat3, strCat4, strCat5, strCat6)
         strHeader = "Top 25 "
      ElseIf optTop50.Checked Then
         objResult = prxAlpha.GetTop50(strCat1, strCat2, strCat3, strCat4, strCat5, strCat6)
         strHeader = "Top 50 "
      ElseIf optTop100.Checked Then
         objResult = prxAlpha.GetTop100(strCat1, strCat2, strCat3, strCat4, strCat5, strCat6)
         strHeader = "Top 100 "
      End If
      strHeader += "Consumer Electronic Products by Net Price"
      dgProds.CaptionText = strHeader

      'Process XmlElement or DataSet objects; the last object displays
      For intObj = 0 To UBound(objResult)
         If objResult(intObj).GetType().ToString() = "System.Xml.XmlElement" Or _
               objResult(intObj).GetType().ToString() = "System.Data.DataSet" Then
            dblConsume = Timer - dblTime
            If objResult(intObj).GetType().ToString() = "System.Data.DataSet" Then
               'Cast to a DataSet
               dsData = objResult(intObj)
               strXmlData = dsData.GetXml()
            Else
               'Cast to an XmlElement
               xmlData = objResult(intObj)
               strXmlData = xmlData.OuterXml
            End If
            'Create a Stream from the String 
            srdData = New StringReader(strXmlData)
            'Load the XmlTextReader with the Stream
            xtrData = New XmlTextReader(srdData)
            With xtrData
               Do While .Read()
                  If .Depth = 2 Then
                     'Column elements
                     drProds = dtProds.NewRow
                     For intCol = 0 To 6
                        'Read the column elements
                        strCol = .ReadElementString
                        If intCol = 5 Then
                           'Format Unit Price as currency
                           strCol = Format(CDec(strCol), "$#,##0.00")
                           blnGotData = True
                        End If
                        drProds(intCol) = strCol
                     Next intCol
                     dtProds.Rows.Add(drProds)
                  End If
               Loop
            End With
            dblTotal = Timer - dblTime
            txtConsume.Text = Format(dblConsume, "#0.000")
            txtTotal.Text = Format(dblTotal, "#0.000")
         ElseIf objResult(intObj).GetType().ToString() = "System.Int32" Then
            If objResult(intObj) <> 0 Then
               'An error occurred, SqlMessage will follow
            End If
         Else
            'The element must be an SqlMessage
            txtHelp.Visible = False
            txtErrors.Visible = True
            If msgError = Nothing Then
               strError = "Error with no message occurred. The stored procedures might not be accessible."
            Else
               strError = msgError.Message + Chr(13) + Chr(10)
               strError += msgError.Source
            End If
            txtErrors.Text = strError
            txtConsume.Text = "Err"
            txtTotal.Text = "Err"
         End If
      Next intObj
      If Not blnGotData Then
         'No records returned
         txtErrors.Text = "Your selection did not return an object. " + Chr(13) + Chr(10) + "Please select at least one category"
         txtHelp.Visible = False
         txtErrors.Visible = True
         txtConsume.Text = "N/A"
         txtTotal.Text = "N/A"
      End If
   End Sub
End Class
