Option Explicit On 
Option Strict On
Imports System.Data.SqlClient
Imports System.IO
Imports System.Xml

Public Class frmHarness
   Inherits System.Windows.Forms.Form

   Private strXML As String
   Private strCrLf As String = Chr(13) + Chr(10)
   Private strTitle As String = "2001 Quarterly Orders by State"
   Private blnNullToZero As Boolean = True
   Private blnRowTotals As Boolean = True
   Private blnColTotals As Boolean = True
   Private dblTimer As Double 'Harness only

   'SOAP Header variables
   Public ServerName As String = "(local)"
   Public UserName As String = "CustUser"
   Public Password As String = "Cust#123"

   'Variables for creating T-SQL queries
   Private strStartDate As String = "1/1/2001"
   Private datStartDate As DateTime = #1/1/2001#
   Private strStartTime As String = "00:00:00 AM"
   Private strInterval As String = "Quarter"
   Private strTitleInt As String = "Quarterly"
   Private strDataCols As String = "4"
   Private strQuery As String
   Private blnStates As Boolean = True

   Friend WithEvents txtDoc As System.Windows.Forms.TextBox
   Friend WithEvents cmdQuery As System.Windows.Forms.Button
   Friend WithEvents lstArray As System.Windows.Forms.ListBox
   Friend WithEvents cmdExecute As System.Windows.Forms.Button
   Friend WithEvents fraLocal As System.Windows.Forms.GroupBox
   Friend WithEvents txtQueryTime As System.Windows.Forms.TextBox
   Friend WithEvents Label1 As System.Windows.Forms.Label
   Friend WithEvents fraWebService As System.Windows.Forms.GroupBox
   Friend WithEvents txtWSTime As System.Windows.Forms.TextBox
   Friend WithEvents Label2 As System.Windows.Forms.Label

#Region " Windows Form Designer generated code "

   Public Sub New()
      MyBase.New()

      'This call is required by the Windows Form Designer.
      InitializeComponent()

      'Add any initialization after the InitializeComponent() call

      cboInterval.Items.Add("Quarter")
      cboInterval.Items.Add("Month")
      cboInterval.Items.Add("Week")
      cboInterval.Items.Add("Day")
      cboInterval.SelectedIndex = 0
      strXML = "<crosstab xmlns='http://oakleaf.ws/services/crosstabs/request' >" + strCrLf + _
               "   <title>2001 Quarterly Orders by State</title>" + strCrLf + _
               "   <timeseries> " + strCrLf + _
               "      <datatable>Orders</datatable>" + strCrLf + _
               "      <rowsby>State</rowsby>" + strCrLf + _
               "      <startdate>1/1/2001</startdate>" + strCrLf + _
               "      <starttime>00:00:00AM</starttime>" + strCrLf + _
               "      <interval>Quarter</interval>" + strCrLf + _
               "      <datacolumns>4</datacolumns>" + strCrLf + _
               "      <count>No</count>" + strCrLf + _
               "      <avgvalue>No</avgvalue>" + strCrLf + _
               "      <rowtotals>Yes</rowtotals>" + strCrLf + _
               "      <coltotals>Yes</coltotals>" + strCrLf + _
               "      <nulltozero>Yes</nulltozero>" + strCrLf + _
               "      <format>XML</format>" + strCrLf + _
               "   </timeseries>" + strCrLf + _
               "</crosstab>"
      txtDoc.Text = strXML
      strTitle = txtTitle.Text
      strInterval = cboInterval.Items(0).ToString
      strDataCols = updDataCols.Value.ToString
      strStartDate = txtStartDate.Text
   End Sub

   'Form overrides dispose to clean up the component list.
   Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
      If disposing Then
         If Not (components Is Nothing) Then
               components.Dispose()
         End If
      End If
      MyBase.Dispose(disposing)
   End Sub
   Friend WithEvents txtTitle As System.Windows.Forms.TextBox
   Friend WithEvents cboInterval As System.Windows.Forms.ComboBox
   Friend WithEvents fraRows As System.Windows.Forms.GroupBox
   Friend WithEvents optStates As System.Windows.Forms.RadioButton
   Friend WithEvents optCategories As System.Windows.Forms.RadioButton
   Friend WithEvents txtStartDate As System.Windows.Forms.TextBox
   Friend WithEvents updDataCols As System.Windows.Forms.NumericUpDown
   Friend WithEvents lblTitle As System.Windows.Forms.Label
   Friend WithEvents lblStartDate As System.Windows.Forms.Label
   Friend WithEvents lblDataCols As System.Windows.Forms.Label
   Friend WithEvents lblInterval As System.Windows.Forms.Label
   Friend WithEvents chkRowTotals As System.Windows.Forms.CheckBox
   Friend WithEvents chkColTotals As System.Windows.Forms.CheckBox
   Friend WithEvents chkNullToZero As System.Windows.Forms.CheckBox
   Friend WithEvents fraFormat As System.Windows.Forms.GroupBox
   Friend WithEvents cmdRequest As System.Windows.Forms.Button
   Friend WithEvents cmdResponse As System.Windows.Forms.Button

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
Me.txtTitle = New System.Windows.Forms.TextBox()
Me.cboInterval = New System.Windows.Forms.ComboBox()
Me.fraRows = New System.Windows.Forms.GroupBox()
Me.optCategories = New System.Windows.Forms.RadioButton()
Me.optStates = New System.Windows.Forms.RadioButton()
Me.txtStartDate = New System.Windows.Forms.TextBox()
Me.updDataCols = New System.Windows.Forms.NumericUpDown()
Me.lblTitle = New System.Windows.Forms.Label()
Me.lblStartDate = New System.Windows.Forms.Label()
Me.lblDataCols = New System.Windows.Forms.Label()
Me.lblInterval = New System.Windows.Forms.Label()
Me.chkRowTotals = New System.Windows.Forms.CheckBox()
Me.chkColTotals = New System.Windows.Forms.CheckBox()
Me.chkNullToZero = New System.Windows.Forms.CheckBox()
Me.fraFormat = New System.Windows.Forms.GroupBox()
Me.txtDoc = New System.Windows.Forms.TextBox()
Me.cmdRequest = New System.Windows.Forms.Button()
Me.cmdResponse = New System.Windows.Forms.Button()
Me.cmdQuery = New System.Windows.Forms.Button()
Me.lstArray = New System.Windows.Forms.ListBox()
Me.cmdExecute = New System.Windows.Forms.Button()
Me.fraLocal = New System.Windows.Forms.GroupBox()
Me.txtQueryTime = New System.Windows.Forms.TextBox()
Me.Label1 = New System.Windows.Forms.Label()
Me.fraWebService = New System.Windows.Forms.GroupBox()
Me.txtWSTime = New System.Windows.Forms.TextBox()
Me.Label2 = New System.Windows.Forms.Label()
Me.fraRows.SuspendLayout()
CType(Me.updDataCols, System.ComponentModel.ISupportInitialize).BeginInit()
Me.fraLocal.SuspendLayout()
Me.fraWebService.SuspendLayout()
Me.SuspendLayout()
'
'txtTitle
'
Me.txtTitle.Location = New System.Drawing.Point(80, 24)
Me.txtTitle.Name = "txtTitle"
Me.txtTitle.Size = New System.Drawing.Size(216, 20)
Me.txtTitle.TabIndex = 0
Me.txtTitle.Text = "2001 Quarterly Orders by State"
'
'cboInterval
'
Me.cboInterval.Location = New System.Drawing.Point(216, 56)
Me.cboInterval.Name = "cboInterval"
Me.cboInterval.Size = New System.Drawing.Size(80, 22)
Me.cboInterval.TabIndex = 1
Me.cboInterval.Text = "Interval"
'
'fraRows
'
Me.fraRows.Controls.AddRange(New System.Windows.Forms.Control() {Me.optCategories, Me.optStates})
Me.fraRows.Location = New System.Drawing.Point(11, 115)
Me.fraRows.Name = "fraRows"
Me.fraRows.Size = New System.Drawing.Size(113, 64)
Me.fraRows.TabIndex = 2
Me.fraRows.TabStop = False
Me.fraRows.Text = "Row Data"
'
'optCategories
'
Me.optCategories.Location = New System.Drawing.Point(8, 40)
Me.optCategories.Name = "optCategories"
Me.optCategories.Size = New System.Drawing.Size(96, 16)
Me.optCategories.TabIndex = 1
Me.optCategories.Text = "By Category"
'
'optStates
'
Me.optStates.Checked = True
Me.optStates.Location = New System.Drawing.Point(8, 16)
Me.optStates.Name = "optStates"
Me.optStates.Size = New System.Drawing.Size(96, 16)
Me.optStates.TabIndex = 0
Me.optStates.TabStop = True
Me.optStates.Text = "By State"
'
'txtStartDate
'
Me.txtStartDate.Location = New System.Drawing.Point(80, 56)
Me.txtStartDate.Name = "txtStartDate"
Me.txtStartDate.Size = New System.Drawing.Size(64, 20)
Me.txtStartDate.TabIndex = 3
Me.txtStartDate.Text = "1/1/2001"
'
'updDataCols
'
Me.updDataCols.Location = New System.Drawing.Point(80, 88)
Me.updDataCols.Minimum = New Decimal(New Integer() {2, 0, 0, 0})
Me.updDataCols.Name = "updDataCols"
Me.updDataCols.Size = New System.Drawing.Size(40, 20)
Me.updDataCols.TabIndex = 4
Me.updDataCols.Value = New Decimal(New Integer() {4, 0, 0, 0})
'
'lblTitle
'
Me.lblTitle.Location = New System.Drawing.Point(13, 27)
Me.lblTitle.Name = "lblTitle"
Me.lblTitle.Size = New System.Drawing.Size(72, 24)
Me.lblTitle.TabIndex = 5
Me.lblTitle.Text = "Report Title:"
Me.lblTitle.TextAlign = System.Drawing.ContentAlignment.TopRight
'
'lblStartDate
'
Me.lblStartDate.Location = New System.Drawing.Point(-3, 59)
Me.lblStartDate.Name = "lblStartDate"
Me.lblStartDate.Size = New System.Drawing.Size(88, 24)
Me.lblStartDate.TabIndex = 6
Me.lblStartDate.Text = "Starting Date:"
Me.lblStartDate.TextAlign = System.Drawing.ContentAlignment.TopRight
'
'lblDataCols
'
Me.lblDataCols.Location = New System.Drawing.Point(-2, 88)
Me.lblDataCols.Name = "lblDataCols"
Me.lblDataCols.Size = New System.Drawing.Size(88, 24)
Me.lblDataCols.TabIndex = 7
Me.lblDataCols.Text = "Data Columns:"
Me.lblDataCols.TextAlign = System.Drawing.ContentAlignment.TopRight
'
'lblInterval
'
Me.lblInterval.Location = New System.Drawing.Point(160, 59)
Me.lblInterval.Name = "lblInterval"
Me.lblInterval.Size = New System.Drawing.Size(56, 24)
Me.lblInterval.TabIndex = 8
Me.lblInterval.Text = "Interval:"
Me.lblInterval.TextAlign = System.Drawing.ContentAlignment.TopRight
'
'chkRowTotals
'
Me.chkRowTotals.Checked = True
Me.chkRowTotals.CheckState = System.Windows.Forms.CheckState.Checked
Me.chkRowTotals.Location = New System.Drawing.Point(191, 107)
Me.chkRowTotals.Name = "chkRowTotals"
Me.chkRowTotals.Size = New System.Drawing.Size(96, 16)
Me.chkRowTotals.TabIndex = 9
Me.chkRowTotals.Text = "Row Totals"
'
'chkColTotals
'
Me.chkColTotals.Checked = True
Me.chkColTotals.CheckState = System.Windows.Forms.CheckState.Checked
Me.chkColTotals.Location = New System.Drawing.Point(191, 131)
Me.chkColTotals.Name = "chkColTotals"
Me.chkColTotals.Size = New System.Drawing.Size(96, 16)
Me.chkColTotals.TabIndex = 10
Me.chkColTotals.Text = "Column Totals"
'
'chkNullToZero
'
Me.chkNullToZero.Checked = True
Me.chkNullToZero.CheckState = System.Windows.Forms.CheckState.Checked
Me.chkNullToZero.Location = New System.Drawing.Point(191, 155)
Me.chkNullToZero.Name = "chkNullToZero"
Me.chkNullToZero.Size = New System.Drawing.Size(100, 16)
Me.chkNullToZero.TabIndex = 11
Me.chkNullToZero.Text = "Null Values = 0"
'
'fraFormat
'
Me.fraFormat.Location = New System.Drawing.Point(183, 91)
Me.fraFormat.Name = "fraFormat"
Me.fraFormat.Size = New System.Drawing.Size(116, 89)
Me.fraFormat.TabIndex = 12
Me.fraFormat.TabStop = False
Me.fraFormat.Text = "Report Format"
'
'txtDoc
'
Me.txtDoc.Location = New System.Drawing.Point(320, 23)
Me.txtDoc.Multiline = True
Me.txtDoc.Name = "txtDoc"
Me.txtDoc.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
Me.txtDoc.Size = New System.Drawing.Size(360, 259)
Me.txtDoc.TabIndex = 13
Me.txtDoc.Text = "Request and Response Documents"
'
'cmdRequest
'
Me.cmdRequest.Location = New System.Drawing.Point(20, 200)
Me.cmdRequest.Name = "cmdRequest"
Me.cmdRequest.Size = New System.Drawing.Size(56, 24)
Me.cmdRequest.TabIndex = 14
Me.cmdRequest.Text = "&Request"
'
'cmdResponse
'
Me.cmdResponse.Location = New System.Drawing.Point(21, 251)
Me.cmdResponse.Name = "cmdResponse"
Me.cmdResponse.Size = New System.Drawing.Size(179, 24)
Me.cmdResponse.TabIndex = 15
Me.cmdResponse.Text = "&Consume XML Web Service"
'
'cmdQuery
'
Me.cmdQuery.Location = New System.Drawing.Point(86, 200)
Me.cmdQuery.Name = "cmdQuery"
Me.cmdQuery.Size = New System.Drawing.Size(46, 24)
Me.cmdQuery.TabIndex = 16
Me.cmdQuery.Text = "&Query"
'
'lstArray
'
Me.lstArray.Font = New System.Drawing.Font("Courier New", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
Me.lstArray.HorizontalScrollbar = True
Me.lstArray.ItemHeight = 14
Me.lstArray.Location = New System.Drawing.Point(12, 292)
Me.lstArray.Name = "lstArray"
Me.lstArray.Size = New System.Drawing.Size(668, 116)
Me.lstArray.TabIndex = 17
'
'cmdExecute
'
Me.cmdExecute.Enabled = False
Me.cmdExecute.Location = New System.Drawing.Point(144, 200)
Me.cmdExecute.Name = "cmdExecute"
Me.cmdExecute.Size = New System.Drawing.Size(56, 24)
Me.cmdExecute.TabIndex = 18
Me.cmdExecute.Text = "E&xecute"
'
'fraLocal
'
Me.fraLocal.Controls.AddRange(New System.Windows.Forms.Control() {Me.txtQueryTime, Me.Label1})
Me.fraLocal.Location = New System.Drawing.Point(12, 184)
Me.fraLocal.Name = "fraLocal"
Me.fraLocal.Size = New System.Drawing.Size(289, 47)
Me.fraLocal.TabIndex = 19
Me.fraLocal.TabStop = False
Me.fraLocal.Text = "Display and Execute Summary Query"
'
'txtQueryTime
'
Me.txtQueryTime.Location = New System.Drawing.Point(198, 18)
Me.txtQueryTime.Name = "txtQueryTime"
Me.txtQueryTime.Size = New System.Drawing.Size(51, 20)
Me.txtQueryTime.TabIndex = 0
Me.txtQueryTime.Text = ""
Me.txtQueryTime.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
'
'Label1
'
Me.Label1.Location = New System.Drawing.Point(252, 21)
Me.Label1.Name = "Label1"
Me.Label1.Size = New System.Drawing.Size(32, 14)
Me.Label1.TabIndex = 20
Me.Label1.Text = "secs"
'
'fraWebService
'
Me.fraWebService.Controls.AddRange(New System.Windows.Forms.Control() {Me.txtWSTime, Me.Label2})
Me.fraWebService.Location = New System.Drawing.Point(12, 235)
Me.fraWebService.Name = "fraWebService"
Me.fraWebService.Size = New System.Drawing.Size(289, 47)
Me.fraWebService.TabIndex = 21
Me.fraWebService.TabStop = False
Me.fraWebService.Text = "Use Client Proxy to Execute Service"
'
'txtWSTime
'
Me.txtWSTime.Location = New System.Drawing.Point(198, 18)
Me.txtWSTime.Name = "txtWSTime"
Me.txtWSTime.Size = New System.Drawing.Size(51, 20)
Me.txtWSTime.TabIndex = 0
Me.txtWSTime.Text = ""
Me.txtWSTime.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
'
'Label2
'
Me.Label2.Location = New System.Drawing.Point(252, 21)
Me.Label2.Name = "Label2"
Me.Label2.Size = New System.Drawing.Size(32, 14)
Me.Label2.TabIndex = 20
Me.Label2.Text = "secs"
'
'frmHarness
'
Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
Me.BackColor = System.Drawing.Color.LightGray
Me.ClientSize = New System.Drawing.Size(692, 421)
Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.cmdExecute, Me.lstArray, Me.cmdQuery, Me.cmdResponse, Me.cmdRequest, Me.txtDoc, Me.chkNullToZero, Me.chkColTotals, Me.chkRowTotals, Me.lblInterval, Me.updDataCols, Me.lblDataCols, Me.txtStartDate, Me.fraRows, Me.cboInterval, Me.txtTitle, Me.fraFormat, Me.lblStartDate, Me.lblTitle, Me.fraLocal, Me.fraWebService})
Me.Font = New System.Drawing.Font("Arial", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
Me.MaximizeBox = False
Me.MinimizeBox = False
Me.Name = "frmHarness"
Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
Me.Text = "OakLeaf Consumer Electronics Orders Crosstab Report Test Harness"
Me.fraRows.ResumeLayout(False)
CType(Me.updDataCols, System.ComponentModel.ISupportInitialize).EndInit()
Me.fraLocal.ResumeLayout(False)
Me.fraWebService.ResumeLayout(False)
Me.ResumeLayout(False)

    End Sub

#End Region

   Public Function TimeSeriesReport(ByVal RequestDoc As String) As String
      'Read the request document and verify its elements
      Dim srdRequest As StringReader = Nothing
      Dim xtrRequest As XmlTextReader = Nothing
      Dim strTemp As String
      Dim strSQL As String
      Dim strResponse As String

      Try
         srdRequest = New StringReader(RequestDoc)
         xtrRequest = New XmlTextReader(srdRequest)
         With xtrRequest
            '(strTemp reads elements not used at this point)
            .MoveToContent()  'Root
            .Read()           'Skip <timeseries>
            strTitle = .ReadElementString("title")
            .Read()           'Skip
            .Read()           'Skip
            strTemp = .ReadElementString("datatable")
            If .ReadElementString("rowsby") = "State" Then
               blnRowTotals = True
            Else
               blnRowTotals = False
            End If
            strStartDate = .ReadElementString("startdate")
            strStartTime = .ReadElementString("starttime")
            strInterval = .ReadElementString("interval")
            strDataCols = .ReadElementString("datacolumns")
            strTemp = .ReadElementString("count")
            strTemp = .ReadElementString("avgvalue")
            If .ReadElementString("rowtotals") = "Yes" Then
               blnRowTotals = True
            Else
               blnRowTotals = False
            End If
            If .ReadElementString("coltotals") = "Yes" Then
               blnColTotals = True
            Else
               blnColTotals = False
            End If
            If .ReadElementString("nulltozero") = "Yes" Then
               blnNullToZero = True
            Else
               blnNullToZero = False
            End If
         End With
      Catch
         'No error processing at this point
      Finally
         srdRequest.Close()
         xtrRequest.Close()
      End Try
      'Generate the T-SQL statement
      strSQL = WriteOrdersQuery()
      'Execute the query and return the report document
      strResponse = GenerateReport(strSQL)
      Return strResponse
   End Function

   '********************************************
   'T-SQL Query and Report Generation Procedures
   '********************************************

   Private Function WriteOrdersQuery() As String
      'Generate the T-SQL query from request document values
      Dim strSelect As String
      Dim strField As String
      Dim strHeader As String
      Dim strPeriod As String
      Dim strYear As String
      Dim datLastDate As DateTime
      Dim strFrom As String
      Dim strWhere As String
      Dim strGroup As String
      Dim strOrder As String
      Dim strSQL As String

      datLastDate = datStartDate
      strFrom = "FROM Customers " + _
         "INNER JOIN Orders ON Customers.CustID = Orders.CustID " + _
         "INNER JOIN LineItems ON Orders.OrderID = LineItems.OrderID "

      strSelect = "SELECT TOP 100 PERCENT "
      strYear = "DATEPART(year, OrderDate)"
      strWhere = "WHERE (OrderDate BETWEEN '" + strStartDate + " " + strStartTime + "' AND '"
      strGroup = "GROUP BY "
      strOrder = "ORDER BY "
      If blnStates Then
         strField = "State"
         strSelect += strField + ", "
      Else
         strField = "SUBSTRING(SKU, 1, 4)"
         strSelect += strField + " AS Category, "
      End If
      strGroup += strField + ", "
      strOrder += strField + ", "

      Select Case strInterval
         Case "Quarter"
            strHeader = "DATENAME(year, OrderDate) + 'Q' + DATENAME(quarter, OrderDate)"
            strPeriod = "DATEPART(quarter, OrderDate)"
            datLastDate = datLastDate.AddMonths(3 * CInt(strDataCols))
         Case "Month"
            strHeader = "SUBSTRING(DATENAME(month, OrderDate), 1, 3) + ' ' + DATENAME(year, OrderDate)"
            strPeriod = "DATEPART(month, OrderDate)"
            datLastDate = datLastDate.AddMonths(CInt(strDataCols))
         Case "Week"
            strHeader = "DATENAME(year, OrderDate) + 'W' + DATENAME(week, OrderDate)"
            strPeriod = "DATEPART(week, OrderDate)"
            datLastDate = datLastDate.AddDays(7 * CInt(strDataCols))
         Case "Day"
            strHeader = "CAST(DATEPART(mm, OrderDate) AS varchar) + '/' + CAST(DATEPART(dd, OrderDate) AS varchar) + '/' + CAST(DATEPART(yy, OrderDate) AS varchar)"
            strPeriod = "DATEPART(dy, OrderDate)"
            datLastDate = datLastDate.AddDays(CInt(strDataCols))
      End Select
      datLastDate = datLastDate.AddSeconds(-1)
      strGroup += strPeriod + ", " + strYear + ", " + strHeader + " "
      strOrder += strPeriod + ", " + strYear + ", " + strHeader + " "
      strPeriod += " AS Period, " + strYear + " AS Year "
      strSelect += strHeader + " AS Header, COUNT(Orders.OrderID) AS Orders, ROUND(SUM(Quantity * UnitPrice), 0) AS Amount, " + strPeriod
      strWhere += Format(datLastDate, "M/d/yyyy hh:mm:ss tt") + "') AND LineItems.Deleted = 0 "

      strSQL = strSelect + strCrLf + strFrom + strCrLf + strWhere + strCrLf + strGroup + strCrLf + strOrder
      Return strSQL
   End Function

   Private Function GenerateReport(ByVal strSQL As String) As String
      'Generate and populate array, and create basic XML response document
      'SOAP headers supply ServerName, UserName, and Password values
      Dim astrCT(,) As String
      Dim intCol As Int32
      Dim intRow As Int32
      Dim intTotal As Int32
      Dim datPeriod As DateTime
      Dim cnnCT As New SqlConnection()
      Dim cmmCT As SqlCommand
      Dim sdrCT As SqlDataReader
      Dim strTemp As String
      Dim strAttrib As String
      Dim strXML As String 'Response document

      'Test harness only
      dblTimer = Microsoft.VisualBasic.Timer

      datPeriod = datStartDate

      If blnStates Then
         ReDim astrCT(13, CInt(strDataCols) + 1)
         astrCT(0, 0) = "State"
         astrCT(1, 0) = "CO"
         astrCT(2, 0) = "IA"
         astrCT(3, 0) = "KS"
         astrCT(4, 0) = "MO"
         astrCT(5, 0) = "MT"
         astrCT(6, 0) = "ND"
         astrCT(7, 0) = "NE"
         astrCT(8, 0) = "NM"
         astrCT(9, 0) = "OK"
         astrCT(10, 0) = "SD"
         astrCT(11, 0) = "TX"
         astrCT(12, 0) = "WY"
         astrCT(13, 0) = "Totals"
      Else
         ReDim astrCT(13, CInt(strDataCols) + 1)
         astrCT(0, 0) = "Category"
         astrCT(1, 0) = "AMPL"
         astrCT(2, 0) = "CAMC"
         astrCT(3, 0) = "CASD"
         astrCT(4, 0) = "CDPL"
         astrCT(5, 0) = "DVDP"
         astrCT(6, 0) = "RCVA"
         astrCT(7, 0) = "RCVH"
         astrCT(8, 0) = "SPKA"
         astrCT(9, 0) = "SPKB"
         astrCT(10, 0) = "SPKF"
         astrCT(11, 0) = "SPKS"
         astrCT(12, 0) = "TVRC"
         astrCT(13, 0) = "Totals"
      End If

      'Generate the time-series column headers
      For intCol = 1 To CInt(strDataCols)
         Select Case strInterval
            Case "Quarter"
               datPeriod = datStartDate.AddMonths(3 * (intCol - 1))
               astrCT(0, intCol) = CStr(datPeriod.Year) + "Q" + CStr((datPeriod.Month \ 3) + 1)
            Case "Month"
               datPeriod = datStartDate.AddMonths(intCol - 1)
               astrCT(0, intCol) = Format(datPeriod, "MMM") + " " + CStr(datPeriod.Year)
            Case "Week"
               datPeriod = datStartDate.AddDays(7 * (intCol - 1))
               If datStartDate = #12/31/2000# And intCol = 1 Then
                  'Special case for 2001, which starts on Monday
                  astrCT(0, intCol) = "2001W1"
               Else
                  astrCT(0, intCol) = CStr(datPeriod.Year) + "W" + CStr((datPeriod.DayOfYear \ 7) + 1)
               End If
            Case "Day"
               datPeriod = datStartDate.AddDays(intCol - 1)
               astrCT(0, intCol) = Format(datPeriod, "M/d/yyyy")
         End Select
      Next intCol
      astrCT(0, CInt(strDataCols) + 1) = "Totals"

      'Fill array with 0s
      For intRow = 1 To UBound(astrCT, 1)
         For intCol = 1 To UBound(astrCT, 2)
            astrCT(intRow, intCol) = "0"
         Next intCol
      Next intRow

      'Connect and create a SqlDataReader
      With cnnCT
         .ConnectionString = "Data Source=" + ServerName + ";Initial Catalog=OCE_Cust;UID=" + UserName + ";PWD=" + Password
         .Open()
         cmmCT = .CreateCommand
      End With
      With cmmCT
         .CommandType = CommandType.Text
         .CommandText = strSQL
         sdrCT = .ExecuteReader
      End With
      With sdrCT
         While .Read
            'Iterate the rowset and plug values into the proper cell
            For intRow = 1 To UBound(astrCT, 1)
               'Find the row
               If sdrCT.GetString(0) = astrCT(intRow, 0) Then
                  Exit For
               End If
            Next intRow
            For intCol = 1 To UBound(astrCT, 2)
               'Find the column
               If sdrCT.GetString(1) = astrCT(0, intCol) Then
                  Exit For
               End If
            Next intCol
            If intRow < UBound(astrCT, 1) And intCol < UBound(astrCT, 2) Then
               'Found the cell; add the value without decimals
               astrCT(intRow, intCol) = CStr(CInt(sdrCT.GetDecimal(3)))
            Else
               'Error below for test
               strTemp = sdrCT.GetString(0) + ", " + sdrCT.GetString(1) + ", " + CStr(sdrCT.GetDecimal(3))
            End If
         End While
      End With
      sdrCT.Close()
      cnnCT.Close()
      'Get row totals
      For intRow = 1 To UBound(astrCT, 1) - 1
         intTotal = 0
         For intCol = 1 To UBound(astrCT, 2) - 1
            intTotal += CInt(astrCT(intRow, intCol))
         Next intCol
         astrCT(intRow, UBound(astrCT, 2)) = CStr(intTotal)
      Next intRow
      'Get column totals (including crossfoot total)
      For intCol = 1 To UBound(astrCT, 2)
         intTotal = 0
         For intRow = 1 To UBound(astrCT, 1) - 1
            intTotal += CInt(astrCT(intRow, intCol))
         Next intRow
         astrCT(UBound(astrCT, 1), intCol) = CStr(intTotal)
      Next intCol
      'Format rows and columns
      For intRow = 1 To UBound(astrCT, 1)
         For intCol = 1 To UBound(astrCT, 2)
            If intRow = 1 Or intRow = UBound(astrCT, 1) Or intCol = UBound(astrCT, 2) Then
               astrCT(intRow, intCol) = Format(CInt(astrCT(intRow, intCol)), "$#,##0")
            Else
               astrCT(intRow, intCol) = Format(CInt(astrCT(intRow, intCol)), "#,##0")
            End If
         Next intCol
      Next intRow

      'For test harness only
      Call PopulateList(astrCT)

      'Generate the response document
      strXML = "<crosstab xmlns='http://oakleaf.ws/services/crosstabs/response' >" + strCrLf
      For intRow = 0 To UBound(astrCT, 1)
         If intRow = UBound(astrCT, 1) And Not blnColTotals Then
            Exit For
         End If
         If intRow = 0 Then
            'Title
            strXML += "   <title>" + strTitle + "</title>" + strCrLf
            'Header
            strXML += "   <header>" + strCrLf + Space(6) + "<row>" + strCrLf
            For intCol = 0 To UBound(astrCT, 2)
               If intCol = UBound(astrCT, 2) And Not blnRowTotals Then
                  Exit For
               End If
               strAttrib = "id='hdr_col_" + astrCT(0, intCol) + "' cell='R1C" + CStr(intCol + 1) + "'"
               strXML += Space(9) + "<col " + strAttrib + ">" + astrCT(intRow, intCol) + "</col>" + strCrLf
            Next intCol
            strXML += Space(6) + "</row>" + strCrLf + "   </header>" + strCrLf
            strXML += "   <data>" + strCrLf
         Else
            'Data rows
            strXML += Space(6) + "<row>" + strCrLf
            For intCol = 0 To UBound(astrCT, 2)
               If intCol = UBound(astrCT, 2) And Not blnRowTotals Then
                  Exit For
               End If
               If intRow = UBound(astrCT, 1) Or intCol = UBound(astrCT, 2) Then
                  strAttrib = "id='total' cell='R" + CStr(intRow + 1) + "C" + CStr(intCol + 1) + "'"
               Else
                  If intCol > 0 Then
                     If blnStates Then
                        strAttrib = "id='st_"
                     Else
                        strAttrib = "id='cat_"
                     End If
                     strAttrib += astrCT(intRow, 0) + "_" + astrCT(0, intCol)
                  Else
                     strAttrib = "id='hdr_row_" + astrCT(intRow, 0)
                  End If
                  strAttrib += "' cell='R" + CStr(intRow + 1) + "C" + CStr(intCol + 1) + "'"
               End If
               If (astrCT(intRow, intCol) = "0" Or astrCT(intRow, intCol) = "$0") And Not blnNullToZero Then
                  'Empty element for zero values
                  strXML += Space(9) + "<col " + strAttrib + "></col>" + strCrLf
               Else
                  strXML += Space(9) + "<col " + strAttrib + ">" + astrCT(intRow, intCol) + "</col>" + strCrLf
               End If
            Next intCol
            strXML += Space(6) + "</row>" + strCrLf
         End If
      Next intRow
      'Close the tags
      strXML += "   </data>" + strCrLf
      strXML += "</crosstab>"
      dblTimer = Microsoft.VisualBasic.Timer - dblTimer

      'Test harness only
      txtQueryTime.Text = Format(dblTimer, "0.0000")
      txtDoc.Text = strXML
      Return strXML
   End Function

   Private Sub PopulateList(ByVal astrArray(,) As String)
      'Test harness only
      Dim intRow As Int32
      Dim intCol As Int32
      Dim strTemp As String
      Dim strArray As String
      lstArray.Items.Clear()
      For intRow = 0 To UBound(astrArray, 1)
         strTemp = ""
         For intCol = 0 To UBound(astrArray, 2)
            strTemp += astrArray(intRow, intCol) + "   "
         Next intCol
         lstArray.Items.Add(strTemp)
         strArray += strTemp + strCrLf
      Next intRow
   End Sub

   '***************************************
   'Command button and mouse event handlers
   '***************************************

   Private Sub cmdResponse_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdResponse.Click
      'Retrieve the XML response document from the ReportsWS service
      'Uncomment the following lines to enable the XML Web service proxy
      Dim xwsReport As New OCEReports.ReportsWS()
      Dim hdrReport As New OCEReports.Authenticate()

      dblTimer = Microsoft.VisualBasic.Timer
      With hdrReport
         .ServerName = "(local)"
         .UserName = "CustUser"
         .Password = "Cust#123"
      End With
      xwsReport.AuthenticateValue = hdrReport
      txtDoc.Text = Replace(xwsReport.TimeSeriesReport(strXML), Chr(10), strCrLf)
      dblTimer = Microsoft.VisualBasic.Timer - dblTimer
      txtWSTime.Text = Format(dblTimer, "0.0000")

      'Comment out the following when using the Web service
      'txtDoc.Text = TimeSeriesReport(strXML)
   End Sub

   Private Sub cmdRequest_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdRequest.Click
      txtDoc.Text = strXML
   End Sub

   Private Sub cmdQuery_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdQuery.Click
      strQuery = WriteOrdersQuery()
      txtDoc.Text = strQuery
      cmdExecute.Enabled = True
   End Sub

   Private Sub cmdExecute_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdExecute.Click
      Dim strReport As String
      strReport = GenerateReport(strQuery)
   End Sub

   Private Sub txtDoc_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles txtDoc.MouseDown
      'Create a Request.xml or Response.xml file and display it in IE
      Dim strFile As String
      Dim filTest As File
      Dim stwTest As StreamWriter
      Dim strShell As String

      If e.Button = MouseButtons.Right Then
         If Mid(txtDoc.Text, 1, 6) <> "SELECT" Then
            If InStr(txtDoc.Text, "<data>") > 0 Then
               strFile = Application.StartupPath + "\Response.xml"
            Else
               strFile = Application.StartupPath + "\Request.xml"
            End If
            'Save the output document as a file and display it in IE
            If filTest.Exists(strFile) Then
               filTest.Delete(strFile)
            End If
            'Get a StreamWriter object and write the document to it
            stwTest = filTest.CreateText(strFile)
            stwTest.Write(txtDoc.Text)
            stwTest.Close()
            strShell = "\Program Files\Internet Explorer\iexplore.exe " & strFile
            Shell(strShell, AppWinStyle.MaximizedFocus)
         End If
      End If
   End Sub

   '****************************************
   'Request document regeneration procedures
   'Top left to bottom right control order
   '****************************************

   Private Sub txtTitle_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtTitle.TextChanged
      'Title
      strXML = Replace(strXML, "<title>" + strTitle + "</title>", "<title>" + txtTitle.Text + "</title>")
      strTitle = txtTitle.Text
      txtDoc.Text = strXML
      cmdExecute.Enabled = False
   End Sub

   Private Sub txtStartDate_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtStartDate.TextChanged
      'Start date
      Try
         If InStr(txtStartDate.Text, "//") = 0 Then
            datStartDate = CDate(txtStartDate.Text)
            If datStartDate.Month > 0 And datStartDate.Day > 0 Then
               If datStartDate >= #1/1/2000# And datStartDate <= #1/1/2005# Then
                  strXML = Replace(strXML, "<startdate>" + strStartDate + "</startdate>", "<startdate>" + Format(datStartDate, "M/d/yyyy") + "</startdate>")
                  strStartDate = Format(datStartDate, "M/d/yyyy")
                  txtDoc.Text = strXML
               End If
            End If
         End If
      Catch
         'Do nothing
      End Try
      cmdExecute.Enabled = False
   End Sub

   Private Sub cboInterval_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboInterval.SelectedIndexChanged
      'Date/Time interval
      Dim strInt As String

      txtStartDate.Text = "1/1/2001"
      With updDataCols
         Select Case cboInterval.SelectedIndex
            Case 0
               .Maximum = 4
               .Value = 4
               strInt = "Quarterly"
            Case 1
               .Maximum = 12
               .Value = 12
               strInt = "Monthly"
            Case 2
               .Maximum = 52
               .Value = 13
               strInt = "Weekly"
               txtStartDate.Text = "12/31/2000" 'Sunday
            Case 3
               .Maximum = 28
               .Value = 7
               strInt = "Daily"
         End Select
      End With
      strXML = Replace(strXML, "<interval>" + strInterval + "</interval>", "<interval>" + CStr(cboInterval.SelectedItem.ToString) + "</interval>")
      strXML = Replace(strXML, strTitleInt, strInt)
      txtTitle.Text = Replace(txtTitle.Text, strTitleInt, strInt)
      strTitleInt = strInt
      strInterval = CStr(cboInterval.SelectedItem.ToString)
      txtDoc.Text = strXML
      cmdExecute.Enabled = False
   End Sub

   Private Sub updDataCols_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles updDataCols.ValueChanged
      'Number of data columns
      strXML = Replace(strXML, "<datacolumns>" + strDataCols + "</datacolumns>", "<datacolumns>" + CStr(updDataCols.Value) + "</datacolumns>")
      strDataCols = CStr(updDataCols.Value)
      txtDoc.Text = strXML
      cmdExecute.Enabled = False
   End Sub

   Private Sub optStates_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles optStates.CheckedChanged
      'State or category values in rows
      If optStates.Checked Then
         strXML = Replace(strXML, "<rowsby>Category</rowsby>", "<rowsby>State</rowsby>")
         txtTitle.Text = Replace(txtTitle.Text, "Category", "State")
         blnStates = True
      Else
         strXML = Replace(strXML, "<rowsby>State</rowsby>", "<rowsby>Category</rowsby>")
         txtTitle.Text = Replace(txtTitle.Text, "State", "Category")
         blnStates = False
      End If
      txtDoc.Text = strXML
      cmdExecute.Enabled = False
   End Sub

   Private Sub chkRowTotals_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkRowTotals.CheckedChanged
      'Row totals
      If chkRowTotals.Checked Then
         strXML = Replace(strXML, "<rowtotals>No</rowtotals>", "<rowtotals>Yes</rowtotals>")
         blnRowTotals = True
      Else
         strXML = Replace(strXML, "<rowtotals>Yes</rowtotals>", "<rowtotals>No</rowtotals>")
         blnRowTotals = False
      End If
      txtDoc.Text = strXML
      cmdExecute.Enabled = False
   End Sub

   Private Sub chkColTotals_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkColTotals.CheckedChanged
      'Column totals
      If chkColTotals.Checked Then
         strXML = Replace(strXML, "<coltotals>No</coltotals>", "<coltotals>Yes</coltotals>")
         blnColTotals = True
      Else
         strXML = Replace(strXML, "<coltotals>Yes</coltotals>", "<coltotals>No</coltotals>")
         blnColTotals = False
      End If
      txtDoc.Text = strXML
      cmdExecute.Enabled = False
   End Sub

   Private Sub chkNullToZero_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkNullToZero.CheckedChanged
      'Substitute zeros for null values
      If chkNullToZero.Checked Then
         strXML = Replace(strXML, "<nulltozero>No</nulltozero>", "<nulltozero>Yes</nulltozero>")
         blnNullToZero = True
      Else
         strXML = Replace(strXML, "<nulltozero>Yes</nulltozero>", "<nulltozero>No</nulltozero>")
         blnNullToZero = False
      End If
      txtDoc.Text = strXML
      cmdExecute.Enabled = False
   End Sub
End Class
