Option Explicit On 
Option Strict On
Imports System.IO
Imports System.Xml

Public Class frmOrders1
   Inherits System.Web.UI.Page

   Private strXML As String
   Private strCrLf As String = Chr(13) + Chr(10)
   Private strTitle As String = "2001 Quarterly Orders by State"
   Private strRowTotals As String = "Yes"
   Private strColTotals As String = "Yes"
   Private strNullToZero As String = "Yes"
   Private dblTimer As Double

   'SOAP Header variables
   Public ServerName As String = "(local)"
   Public UserName As String = "CustUser"
   Public Password As String = "Cust#123"

   'Variables for creating T-SQL queries
   Private strStartDate As String = "1/1/2001"
   Private datStartDate As DateTime = #1/1/2001#
   Private strStartTime As String = "00:00:00 AM"
   Private strInterval As String = "Quarter"
   Private strTitleInt As String = "Quarterly"
   Private strDataCols As String = "4"
   Private strQuery As String

   Protected WithEvents lblTitle As System.Web.UI.WebControls.Label
   Protected WithEvents rblRowsBy As System.Web.UI.WebControls.RadioButtonList
   Protected WithEvents lblStartDate As System.Web.UI.WebControls.Label
   Protected WithEvents lblInterval As System.Web.UI.WebControls.Label
   Protected WithEvents lblDataCols As System.Web.UI.WebControls.Label
   Protected WithEvents lblRowsBy As System.Web.UI.WebControls.Label
   Protected WithEvents lblFormat As System.Web.UI.WebControls.Label
   Protected WithEvents txtUserID As System.Web.UI.WebControls.TextBox
   Protected WithEvents lblUserID As System.Web.UI.WebControls.Label
   Protected WithEvents lblPassword As System.Web.UI.WebControls.Label
   Protected WithEvents txtPassword As System.Web.UI.WebControls.TextBox
   Protected WithEvents cmdResponse As System.Web.UI.WebControls.Button
   Protected WithEvents cblFormat As System.Web.UI.WebControls.CheckBoxList
   Protected WithEvents ddlDataCols As System.Web.UI.WebControls.DropDownList
   Protected WithEvents ddlInterval As System.Web.UI.WebControls.DropDownList
   Protected WithEvents ddlMonth As System.Web.UI.WebControls.DropDownList
   Protected WithEvents ddlDay As System.Web.UI.WebControls.DropDownList
   Protected WithEvents ddlYear As System.Web.UI.WebControls.DropDownList
   Protected WithEvents txtDoc As System.Web.UI.WebControls.TextBox
   Protected WithEvents tblReport As System.Web.UI.WebControls.Table
   Protected WithEvents chkRemoteWS As System.Web.UI.WebControls.CheckBox
   Private blnStates As Boolean = True

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

   Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
      'Put user code to initialize the page here
      txtUserID.Text = "CustUser"   'Not required (text box value)
      txtPassword.Text = "Cust#123" 'Required for TextMode = Password 
   End Sub

   Private Sub ddlInterval_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs)
      With ddlInterval
         strInterval = .SelectedItem.ToString
         If .SelectedIndex = 0 Then
            'Quarterly - 4 quarters
            ddlDataCols.SelectedIndex = 3
            strTitleInt = "Quarterly"
         ElseIf .SelectedIndex = 1 Then
            'Monthly - 12 months
            ddlDataCols.SelectedIndex = 11
            strTitleInt = "Monthly"
         ElseIf .SelectedIndex = 2 Then
            'Weekly - 13 weeks
            ddlDataCols.SelectedIndex = 12
            strTitleInt = "Weekly"
         ElseIf .SelectedIndex = 3 Then
            'Daily - one week
            strTitleInt = "Daily"
            ddlDataCols.SelectedIndex = 6
         End If
      End With
   End Sub

   Private Sub cmdResponse_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdResponse.Click
      'Create XML request document
      'Retrieve the XML response document from the ReportsWS service
      Dim xwsReport As New OCEReports.ReportsWS()
      Dim hdrReport As New OCEReports.Authenticate()
      Dim xwsRemote As New RemReports.ReportsWS()
      Dim hdrRemote As New RemReports.Authenticate()
      Dim strResponse As String

      'Generate the title
      strTitle = ddlYear.SelectedItem.Value.ToString + " " + ddlInterval.SelectedItem.Value.ToString + _
         " Orders by " + rblRowsBy.SelectedItem.Value.ToString

      'Set the start date
      strStartDate = ddlMonth.SelectedItem.Value.ToString + "/" + _
                     ddlDay.SelectedItem.Value.ToString + "/" + _
                     ddlYear.SelectedItem.Value.ToString

      'Assign the formatting criteria
      If cblFormat.Items(0).Selected Then
         strRowTotals = "Yes"
      Else
         strRowTotals = "No"
      End If
      If cblFormat.Items(1).Selected Then
         strColTotals = "Yes"
      Else
         strColTotals = "No"
      End If
      If cblFormat.Items(2).Selected Then
         strNullToZero = "Yes"
      Else
         strNullToZero = "No"
      End If

      'Generate the request document
      strXML = "<crosstab xmlns='http://oakleaf.ws/services/crosstabs/request' >" + strCrLf + _
               "   <title>" + strTitle + "</title>" + strCrLf + _
               "   <timeseries> " + strCrLf + _
               "      <datatable>Orders</datatable>" + strCrLf + _
               "      <rowsby>" + rblRowsBy.SelectedItem.Value.ToString + "</rowsby>" + strCrLf + _
               "      <startdate>" + strStartDate + "</startdate>" + strCrLf + _
               "      <starttime>00:00:00AM</starttime>" + strCrLf + _
               "      <interval>" + ddlInterval.SelectedItem.ToString + "</interval>" + strCrLf + _
               "      <datacolumns>" + ddlDataCols.SelectedItem.ToString + "</datacolumns>" + strCrLf + _
               "      <count>No</count>" + strCrLf + _
               "      <avgvalue>No</avgvalue>" + strCrLf + _
               "      <rowtotals>" + strRowTotals + "</rowtotals>" + strCrLf + _
               "      <coltotals>" + strColTotals + "</coltotals>" + strCrLf + _
               "      <nulltozero>" + strNullToZero + "</nulltozero>" + strCrLf + _
               "      <format>XML</format>" + strCrLf + _
               "   </timeseries>" + strCrLf + _
               "</crosstab>"
      If chkRemoteWS.Checked Then
         With hdrRemote
            'Supply the SOAP header values
            .ServerName = "OAKLEAF-MS7"
            .UserName = txtUserID.Text
            .Password = txtPassword.Text
         End With
         xwsRemote.AuthenticateValue = hdrRemote
         txtDoc.Text = Replace(xwsRemote.TimeSeriesReport(strXML), Chr(10), strCrLf)
      Else
         With hdrReport
            'Supply the SOAP header values
            .ServerName = "(local)"
            .UserName = txtUserID.Text
            .Password = txtPassword.Text
         End With
         xwsReport.AuthenticateValue = hdrReport
         txtDoc.Text = Replace(xwsReport.TimeSeriesReport(strXML), Chr(10), strCrLf)
      End If
   End Sub
End Class
