Option Explicit On 
Option Strict On
Imports System.IO
Imports System.Xml

Public Class frmCTReport
   Inherits System.Web.UI.Page

   Private strXML As String
   Private strCrLf As String = Chr(13) + Chr(10)
   Private strTitle As String = "2001 Quarterly Orders by State"
   Private strRowTotals As String = "Yes"
   Private strColTotals As String = "Yes"
   Private strNullToZero As String = "Yes"

   'SOAP Header variables
   Public ServerName As String = "(local)"
   Public UserName As String = "CustUser"
   Public Password As String = "Cust#123"

   'Variables for creating T-SQL queries
   Private strStartDate As String = "1/1/2001"
   Private datStartDate As DateTime = #1/1/2001#
   Private strStartTime As String = "00:00:00 AM"
   'Private strInterval As String '= "Quarter"
   Private strTitleInt As String = "Quarterly"
   Private strDataCols As String = "4"
   Private strQuery As String
   Private blnStates As Boolean = True

   Protected WithEvents lblTitle As System.Web.UI.WebControls.Label
   Protected WithEvents rblRowsBy As System.Web.UI.WebControls.RadioButtonList
   Protected WithEvents lblStartDate As System.Web.UI.WebControls.Label
   Protected WithEvents lblInterval As System.Web.UI.WebControls.Label
   Protected WithEvents lblDataCols As System.Web.UI.WebControls.Label
   Protected WithEvents lblRowsBy As System.Web.UI.WebControls.Label
   Protected WithEvents lblFormat As System.Web.UI.WebControls.Label
   Protected WithEvents txtUserID As System.Web.UI.WebControls.TextBox
   Protected WithEvents lblUserID As System.Web.UI.WebControls.Label
   Protected WithEvents lblPassword As System.Web.UI.WebControls.Label
   Protected WithEvents txtPassword As System.Web.UI.WebControls.TextBox
   Protected WithEvents cmdResponse As System.Web.UI.WebControls.Button
   Protected WithEvents cblFormat As System.Web.UI.WebControls.CheckBoxList
   Protected WithEvents tblReport As System.Web.UI.WebControls.Table
   Protected WithEvents ddlDataCols As System.Web.UI.WebControls.DropDownList
   Protected WithEvents ddlMonth As System.Web.UI.WebControls.DropDownList
   Protected WithEvents ddlDay As System.Web.UI.WebControls.DropDownList
   Protected WithEvents ddlInterval As System.Web.UI.WebControls.DropDownList
   Protected WithEvents txtInterval As System.Web.UI.WebControls.TextBox
   Protected WithEvents chkRemoteWS As System.Web.UI.WebControls.CheckBox
   Protected WithEvents ddlYear As System.Web.UI.WebControls.DropDownList

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

   Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
      'Put user code to initialize the page here
      txtUserID.Text = "CustUser"
      txtPassword.Text = "Cust#123"
   End Sub

   Private Sub cmdResponse_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdResponse.Click
      'Create XML request document
      'Retrieve the XML response document from the ReportsWS service
      Dim xwsReport As New OCEReports.ReportsWS()
      Dim hdrReport As New OCEReports.Authenticate()
      Dim xwsRemote As New RemReports.ReportsWS()
      Dim hdrRemote As New RemReports.Authenticate()
      Dim strResponse As String
      Dim datStartDate As DateTime

      If Trace.IsEnabled Then
         Trace.Write("Start prepare request")
      End If

      'Generate the title
      strTitle = ddlYear.SelectedItem.Value.ToString + " " + ddlInterval.SelectedItem.Value.ToString + _
         " Orders by " + rblRowsBy.SelectedItem.Value.ToString

      'Validate day value
      With ddlMonth.SelectedItem
         If .ToString = "Feb" And ddlDay.SelectedIndex > 27 Then
            ddlDay.SelectedIndex = 27
         End If
         If InStr("Apr Jun Sep Nov", .ToString) > 0 And ddlDay.SelectedIndex = 30 Then
            '30 days hath September...
            ddlDay.SelectedIndex = 29
         End If
      End With

      'Start reports on interval boundaries and set date dropdowns
      Select Case ddlInterval.SelectedItem.ToString
         Case "Quarter"
            ddlDay.SelectedIndex = 0
            If InStr("1369", ddlMonth.SelectedItem.Value.ToString) = 0 Then
               Select Case Val(ddlMonth.SelectedItem.Value.ToString)
                  Case Is > 9
                     ddlMonth.SelectedIndex = 8
                  Case Is > 6
                     ddlMonth.SelectedIndex = 5
                  Case Is > 3
                     ddlMonth.SelectedIndex = 2
                  Case Else
                     ddlMonth.SelectedIndex = 0
               End Select
            End If
         Case "Month"
            'First of month
            ddlDay.SelectedIndex = 0
         Case "Week"
            'Go to the preceding Sunday
            strStartDate = ddlMonth.SelectedItem.Value.ToString + "/" + _
                           ddlDay.SelectedItem.Value.ToString + "/" + _
                           ddlYear.SelectedItem.Value.ToString
            datStartDate = CDate(strStartDate)
            If datStartDate.DayOfWeek <> DayOfWeek.Sunday And datStartDate <> #1/1/2001# Then
               '1/1/2001 is special-cased by the service
               datStartDate = datStartDate.AddDays(-CInt(datStartDate.DayOfWeek))
               If datStartDate = #12/31/2000# Then
                  ddlMonth.SelectedIndex = 0
                  ddlDay.SelectedIndex = 0
                  ddlYear.SelectedIndex = 1
               Else
                  ddlMonth.SelectedIndex = datStartDate.Month - 1
                  ddlDay.SelectedIndex = datStartDate.Day - 1
               End If
            End If
      End Select

      'Set the start date
      strStartDate = ddlMonth.SelectedItem.Value.ToString + "/" + _
                     ddlDay.SelectedItem.Value.ToString + "/" + _
                     ddlYear.SelectedItem.Value.ToString
      'Assign the formatting criteria
      If cblFormat.Items(0).Selected Then
         strRowTotals = "Yes"
      Else
         strRowTotals = "No"
      End If
      If cblFormat.Items(1).Selected Then
         strColTotals = "Yes"
      Else
         strColTotals = "No"
      End If
      If cblFormat.Items(2).Selected Then
         strNullToZero = "Yes"
      Else
         strNullToZero = "No"
      End If

      'Generate the request document
      strXML = "<crosstab xmlns='http://oakleaf.ws/services/crosstabs/request' >" + strCrLf + _
               "   <title>" + strTitle + "</title>" + strCrLf + _
               "   <timeseries> " + strCrLf + _
               "      <datatable>Orders</datatable>" + strCrLf + _
               "      <rowsby>" + rblRowsBy.SelectedItem.Value.ToString + "</rowsby>" + strCrLf + _
               "      <startdate>" + strStartDate + "</startdate>" + strCrLf + _
               "      <starttime>00:00:00AM</starttime>" + strCrLf + _
               "      <interval>" + ddlInterval.SelectedItem.ToString + "</interval>" + strCrLf + _
               "      <datacolumns>" + ddlDataCols.SelectedItem.ToString + "</datacolumns>" + strCrLf + _
               "      <count>No</count>" + strCrLf + _
               "      <avgvalue>No</avgvalue>" + strCrLf + _
               "      <rowtotals>" + strRowTotals + "</rowtotals>" + strCrLf + _
               "      <coltotals>" + strColTotals + "</coltotals>" + strCrLf + _
               "      <nulltozero>" + strNullToZero + "</nulltozero>" + strCrLf + _
               "      <format>XML</format>" + strCrLf + _
               "   </timeseries>" + strCrLf + _
               "</crosstab>"
      If Trace.IsEnabled Then
         Trace.Write("Start send request")
      End If
      If chkRemoteWS.Checked Then
         With hdrRemote
            'Supply the SOAP header values
            .ServerName = "OAKLEAF-MS7"
            .UserName = txtUserID.Text
            .Password = txtPassword.Text
         End With
         xwsRemote.AuthenticateValue = hdrRemote
      Else
         With hdrReport
            'Supply the SOAP header values
            .ServerName = "(local)"
            .UserName = txtUserID.Text
            .Password = txtPassword.Text
         End With
         xwsReport.AuthenticateValue = hdrReport
      End If
      If Trace.IsEnabled Then
         Trace.Write("End receive response")
         Trace.Write("Start fill table")
      End If
      If chkRemoteWS.Checked Then
         Call FillTable(xwsRemote.TimeSeriesReport(strXML))
      Else
         Call FillTable(xwsReport.TimeSeriesReport(strXML))
      End If
      If Trace.IsEnabled Then
         Trace.Write("End fill table")
      End If
   End Sub

   Private Sub FillTable(ByVal strResponse As String)
      'Fill the table with the crosstab data
      Dim srdTable As StringReader = Nothing
      Dim xtrTable As XmlTextReader = Nothing
      Dim celTable As TableCell = Nothing
      Dim strTitle As String
      Dim blnFirstCol As Boolean
      Dim blnColHeader As Boolean

      srdTable = New StringReader(strResponse)
      xtrTable = New XmlTextReader(srdTable)
      With xtrTable
         .Read()  '<crosstab>
         .Read()  '<title>
         strTitle = "OakLeaf Consumer Electronics " + .ReadElementString("title")
         'Add a title header row
         Dim rowHeader As New TableRow()
         Dim celHeader As New TableHeaderCell()
         With celHeader
            .HorizontalAlign = HorizontalAlign.Center
            'Decimal value for #266294 plus 20% luminance
            .BackColor = Color.FromArgb(50, 110, 160)
            .ForeColor = Color.White
            .ID = "title"
            If strColTotals = "Yes" Then
               'Set the colspan attribute value
               .ColumnSpan = ddlDataCols.SelectedIndex + 3
            Else
               .ColumnSpan = ddlDataCols.SelectedIndex + 2
            End If
            .Text() = strTitle
            'Add the title header row
            rowHeader.Cells.Add(celHeader)
            tblReport.Rows.Add(rowHeader)
         End With
         blnColHeader = True
         While .Read
            If .HasAttributes Then
               'It's a cell, create a row
               blnFirstCol = True
               Dim rowTable As New TableRow()
               rowTable.HorizontalAlign = HorizontalAlign.Right
               While .HasAttributes
                  'Add the cells to the row
                  If blnColHeader Then
                     Dim celColHeader As New TableHeaderCell()
                     With celColHeader
                        .BackColor = Color.FromArgb(50, 110, 160)
                        .ForeColor = Color.White
                     End With
                     celTable = celColHeader
                  Else
                     celTable = New TableCell()
                  End If
                  With celTable
                     If blnFirstCol Then
                        .HorizontalAlign = HorizontalAlign.Center
                     End If
                     'id attribute
                     .ID = xtrTable.GetAttribute(0).ToString
                     .Text = xtrTable.ReadElementString
                  End With
                  rowTable.Cells.Add(celTable)
                  .Read()
                  blnFirstCol = False
               End While
               'Add the row to the table
               tblReport.Rows.Add(rowTable)
               blnColHeader = False
            End If
         End While
      End With
   End Sub

   Private Sub ddlInterval_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ddlInterval.SelectedIndexChanged
      With ddlInterval
         If .SelectedItem.ToString = txtInterval.Text Then
            'There was no change
            Exit Sub
         End If
         txtInterval.Text = .SelectedItem.ToString
         If .SelectedIndex = 0 Then
            'Quarterly - 4 quarters
            ddlDataCols.SelectedIndex = 3
            strTitleInt = "Quarterly"
         ElseIf .SelectedIndex = 1 Then
            'Monthly - 12 months
            ddlDataCols.SelectedIndex = 11
            strTitleInt = "Monthly"
         ElseIf .SelectedIndex = 2 Then
            'Weekly - 13 weeks
            ddlDataCols.SelectedIndex = 12
            strTitleInt = "Weekly"
         ElseIf .SelectedIndex = 3 Then
            'Daily - one week
            strTitleInt = "Daily"
            ddlDataCols.SelectedIndex = 6
         End If
      End With
   End Sub
End Class
